
#ifndef P_UBYTE /* { */
#define P_UBYTE volatile unsigned char *
#define P_UWORD volatile unsigned short *
#define P_ULONG volatile unsigned long *
#endif /* } */

#define UBYTE unsigned char
#define UWORD unsigned short
#define ULONG unsigned long


#define PCI_IO_WIN 0xfe240000		/* PCI-IO SH 256K */
#define PCI_MEM_WIN 0xfd000000		/* PCI-MEM SH 16M */
#define PCI_MEM_BNK_ADR 0xfe2001c4	/* bit[31:24] ... (bit0=LOCK) MBR */
#define PCI_IO_BNK_ADR 0xfe2001c8	/* bit[31:18] ... (bit0=LOCK) MBR */

#define LED	(P_UWORD)0xa3000000	/* KZSH4 7segLED */


/********** PCI memory map ************/
#define PCI_SRAM_ADR 0xfe000000		/* SH4 SRAM(10000000h) */
#define PCI_DRAM_ADR 0xff000000		/* SH4 SDRAM(08000000h) */


/********** PCI I/O map ************/
#define PCI_PCIC_ADR 0xfff00000		/* SH4 PCIC */



/********** SH4 local memory map ************/
#define SH4_SRAM_ADR 0x10000000		/* SH4 AREA4 SRAM(10000000h) */
//#define SH4_DRAM_ADR 0x08000000	/* SH4 AREA2 SDRAM(08000000h) */
#define SH4_DRAM_ADR 0x0c000000		/* SH4 AREA3 SDRAM(0c000000h) */



/********** m1543.c ***********/
/****** bios.c ************/
extern pci_iowrb(UWORD adr,UBYTE data);
extern pci_iowrw(UWORD adr,UWORD data);
extern pci_iowrl(UWORD adr,ULONG data);

extern UBYTE pci_iordb(UWORD adr);
extern UWORD pci_iordw(UWORD adr);
extern ULONG pci_iordl(UWORD adr);

extern pci_cfgwr(UBYTE bus_no,UBYTE dev_no,UBYTE func_no,UBYTE adr,ULONG data);
extern ULONG pci_cfgrd(UBYTE bus_no,UBYTE dev_no,UBYTE func_no,UBYTE adr);

extern ULONG cvt_SH2PCI(ULONG adr);


extern cache_flush();
extern cache_on(int flg);

/*********** ide.c ************/
extern ide_init();
extern ide_stat();
extern ide_sect_rd(UBYTE *buf,UBYTE drv,ULONG lba,UBYTE sect_ct,int noretry);
extern ide_sect_wr(UBYTE *buf,UBYTE drv,ULONG lba,UBYTE sect_ct,int noretry);
extern UBYTE *ide_drv_inf(UBYTE drv);
