/************************************************************
  load.c ( ext2 filesystem load)
  Copyright (C) 2000,2001 Nobuhiro Sakawa
  Date: 2001/06/14
  Revision: 1.0 $
*************************************************************/
# if 0
#define DEBUG 
#endif

#include "elfb.h"

#define CD_BSIZE		2048
extern char *load_address;
extern int disk_error;

static unsigned char super_block[2048];
static unsigned char dir_block[4096];

static fdump(char *block)
{
	dbcommand(0,block,block + 2045);
}


long cd_load(s, get_block)
char *s;
int (*get_block)();
{
	long dir_block_num,  dir_blocks;
	long data_block_num, data_blocks;
	long block;
	int  len, i, j, k, disp_cnt, s2set;
	char *dir;
	struct elf32hed   *elfhead;
	unsigned long s1last_addr, s2start_addr;

	disk_error = 0;
	if ((*get_block)(16, super_block)) {
	  	sshprintk("get_block error \n");
	  	disk_error = 1;
		return -1;
	}
	if (super_block[0] != 0x01) {
		sshprintk("iso9660 Mgic Error\n");
	}
	dir_block_num = (super_block[0x9e]) + (super_block[0x9f]*256);
	dir_blocks    = (super_block[0xa6]) + (super_block[0xa7]*256);
	dir_blocks    = dir_blocks / CD_BSIZE;

	while( *s == '/' )  s++;
	len = strlen(s);

	for(i=0; i < dir_blocks; i++) {
		if ((*get_block)(dir_block_num + i, dir_block)) {
			sshprintk("get_block error \n");
			disk_error = 1;
			return -1;
		}
		for(j=0; dir_block[j] != 0; j += dir_block[j]) {
			dir = (char *)&dir_block[j];
			k = dir[32] + 44;
			if (dir[32] % 2)  k--;
			if ( !strncmp(s, &dir[k], len)) {
				goto found; /*continue;*/
			}
		}
	}
	return -1;
found:;
	data_block_num = (((dir[5]*256)+dir[4])*256+dir[3])*256+dir[2];
	data_blocks    = (((dir[13]*256)+dir[12])*256+dir[11])*256+dir[10];
	data_blocks = data_blocks / CD_BSIZE + 1;
	disp_cnt = s2set = 0;

	for (block = 0; block <= data_blocks; ++block) {
		/*** oasobi ***/
		if(disp_cnt++ > 20) { sshprintk("."); disp_cnt = 0; }
		/**************/
		if ((*get_block)(data_block_num + block, (char *)load_address)) {
			sshprintk("get_block error \n");
			disk_error = 1;
			return -1;
		}
		if(block == 0) {
			elfhead = (struct elf32hed *)load_address;
			s1last_addr  = elfhead->sh1_entry + elfhead->sh1_size;
			s2start_addr = elfhead->sh2_entry;
		}
		load_address += CD_BSIZE; 
		if(load_address >= (char *)s1last_addr ) {
			if(load_address < (char *)s2start_addr ) {
				if (!s2set) { s2set = 1;
					load_address += 0x1000;
/*nsakawa korega seikai?
					load_address = (char *)s2start_addr;
*/
				}
			}
		}
	}
 	return (((dir[13]*256)+dir[12])*256+dir[11])*256+dir[10];
}
