/****************************************************************/
/*            commannd program                                  */
/*								*/
/* Copyright (C) 1998 Nobuhiro Sakawa				*/
/*								*/
/****************************************************************/
/*
#include <ctype.h>
*/
#include	"cmd.h"		/*  command header		*/

int		Holdcom;        /* save previous command (default:DB) */
unsigned short	Holdadrs;       /* set 0		*/
unsigned long	Holdadro;       /* save executed address	*/
int		prflag;	        /* control print out by ctrl_p	*/
char		echooff;

/********************************************************************/
/*          console main job                                        */
/********************************************************************/
void cmd()
{
	char buffer[100];
	char *p;
		echooff = 0;
		get_string( buffer);
		p = buffer;
		switch (*p) {
			case 'h':
			case '?':	help_msg();
					break;
			case 'D':	dump_com(p);
					break;
			case 'E':	enter_com(p);
					break;
			case 'F':	fill_com(p);
					break;
			case 'M':	mcopy_com(p);
					break;
/* S format read
			case 'L':   	mem_load(p);
					break;
*/
			case 'b':	hd_do_boot(p);
					break;
			case 'c':	cd_do_boot(p);
					break;
			case 'f':	cf_do_boot(p);
					break;
/* flush write
			case 'w':	fw();
					break;
*/
			default:	strout("Unknown Command >  ");
					strout( buffer );
					strout("\nType h for help\n");
					break;
		}
		strout("Command? ");
}

/****************************************************************/
/*		D? command					*/
/*			[DA]/[DB]/[DW]/[D]			*/
/*		string : command string;			*/
/****************************************************************/
int  dump_com( string )
char	* string;
{
	int		i;		/* position of string */
	int		m;		/* return value area  */

	Holdadrs = 0;
	convstol(string);		/* small letter to upper */
	i = 2;
	switch (string[1]) {		/* 2 position character ? */
		case 'A':
			getdmp_adr(string , &i, DA);	/* DA command */
			break;
		case 'B':
			getdmp_adr(string , &i, DB);	/* DB command */
			break;
		case 'W':
			getdmp_adr(string , &i, DW);	/* DW command	*/
			break;
		case ' ':
		case '\0':
			i = 1;
			getdmp_adr(string, &i, Holdcom);  /* previous dump */
			break;
		default:
			if((string[1]>='0')&&(string[1]<='9')){
				i=1;
				getdmp_adr(string,&i,Holdcom);
				break;
			}else{
				strout("error");
				strout(string);
				strout("\n");
				/** errorout(2); **/	/* not dump */
			}
			break;
	}
	Hold_cmd = Holdcom+1;		/* save command No. */

	if( Holdcom == DW )		m = *(unsigned short *)(Holdadro -2);
	else	m = *(unsigned char *)(Holdadro -1);
	return(m);

}

/****************************************************************/
/*	get dump address					*/
/*	string : addr.str	i : length			*/
/*	get add: DA / DB / DW					*/
/****************************************************************/
void getdmp_adr( string , i , type )
char *string;
int  *i;
int   type;
{
	int errf;		/* error flag    */
	unsigned long adr1;	/* start address */
	unsigned long adr2;	/* end address 	 */

	for( ; string[*i]==SPACE; ++(*i) );		/* space cut */
	errf=NOERR;
	adr1=Holdadro;					/* start addr. previous */
	if(string[*i]!=','){
		errf = get_dadr(string, i, &adr1);	/* get start address */
		for( ; string[*i]==SPACE ; ++(*i) );	/* space cut */
	}
	if(string[*i]==',')	++(*i);			/* index skip */
	if(type == DW) {
		adr1 = adr1 & 0xfffffffe;
	}
	switch( errf ) {
	case NOERR:						/* start address is normal */
		errf = get_dadr(string, i, &adr2);		/* get end address */
		if (errf == END &&  checkadr(adr1, adr2) == NOERR)
           	seldmpcom(type,(int)Holdadrs, adr1, adr2, ADR2);    /* dump*/
		else
			errorout(*i);	/* input error of end address 	*/
		break;
 	case END:			/* input only start address 	*/
   		seldmpcom(type,(int)Holdadrs, adr1, adr2, ADR1);    /* dump*/
		break;
	case NOT:			/* input only dump command 	*/
   		seldmpcom(type, (int)Holdadrs, (int)Holdadro, adr2, ADR0);  /* dump */
		break;
	default:
		errorout(*i);	/* input error 	*/
		break;
	}
}

/****************************************************************/
/*	select dump command(DA,DB,DW)				*/
/*	if address is not input, set start & end address	*/
/*	type : (DA, DB, DW)					*/
/*	stadr : start address					*/
/*	endadr : end address					*/
/*	adrmode : input mode of address				*/
/****************************************************************/
void seldmpcom( type , segadr , stadr , endadr , adrmode )
int type;
unsigned long segadr, stadr, endadr, adrmode;
{

	switch (adrmode) {
	case ADR2:		/* mode is start & end 	*/
		Setdadr2(type, stadr, endadr);
		break;
	case ADR1:		/* mode is only start 	*/
		Setdadr1(type, stadr);
		break;
	case ADR0:		/* address is no input mode 	*/
		Setdadr0(type);
		break;
	default:
		break;
	}
	Holdcom = type;		/*  save executed command  */
}

/****************************************************************/
/*	dump  (address mode is start & end address)	    	*/
/*	type: (DA, DB, DW)					*/
/*	stadr : start address;					*/
/*	endadr : end address;					*/
/****************************************************************/
void Setdadr2( type , stadr , endadr )
int    type;
unsigned long stadr, endadr;
{

	switch(type) {
	case DA:
		dacommand(Holdadrs, stadr, endadr);	/* DA command	*/
		break;
	case DB:
		dbcommand(Holdadrs, stadr, endadr);	/* DB command 	*/
		break;
	case DW:
		dwcommand(Holdadrs, stadr, endadr);	/* DW command 	*/
		if (endadr-stadr-((endadr-stadr)/2)*2 == 0) endadr++;
		break;
	default:
		break;
	}
	Holdadro = endadr + 1;		/* save end address */
}

/****************************************************************/
/*	dump (input is start address mode)			*/
/*	type: (DA, DB, DW)					*/
/*	stadr : dump start address;				*/
/****************************************************************/
void Setdadr1( type , stadr )
int    type;
unsigned long stadr;
{
	unsigned long endadr;

	switch(type) {
	case DA:
		endadr = stadr + (SZ_DADEF -1);		/* get end address  */
		if (endadr < stadr)
			endadr = 0xFFFFffff;		/* phisical end */
		dacommand(Holdadrs, stadr, endadr);	/* DA command 	*/
		break;
	case DB:
		endadr = stadr + (SZ_DBDEF -1);		/* get end address  */
		if (endadr < stadr)
			endadr = 0xFFFFffff;		/* phisical end */
		dbcommand(Holdadrs, stadr, endadr);	/* DB command 	*/
		break;
	case DW:
		endadr = stadr + (SZ_DWDEF -1);		/* get end address  */
		if (endadr < stadr)
			endadr = 0xFFFFffff;		/* phisical end */
		dwcommand(Holdadrs, stadr, endadr);	/* DW command 	*/
		break;
	default:
		break;
	}
	Holdadro = endadr + 1;		/* save end address  */
}

/****************************************************************/
/*	dump (adress mode is no input)				*/
/*	type	(DA, DB, DW)					*/
/****************************************************************/
void Setdadr0( type )
int type;
{
	 unsigned long endadr;		/* dump end address	*/

	switch(type) {
	case DA:
		endadr = Holdadro + (SZ_DADEF -1);	/* get end address*/
		if (endadr < Holdadro)
			endadr = 0xFFFFffff;
		dacommand(Holdadrs, Holdadro, endadr);	/* DA command 	*/
		break;
	case DB:
		endadr = Holdadro + (SZ_DBDEF-1);	/* get end address*/
		if (endadr < Holdadro)
			endadr = 0xFFFFffff;
		dbcommand(Holdadrs, Holdadro, endadr);	/* DB command 	*/
		break;
	case DW:
		endadr = Holdadro + (SZ_DWDEF -1);	/* get end address*/
		if (endadr < Holdadro)
			endadr = 0xFFFFffff;
		dwcommand(Holdadrs, Holdadro, endadr);	/* DW command 	*/
		break;
	default:
		break;
	}
	Holdadro = endadr + 1;	/* save dump end address */
}

/****************************************************************/
/*	display command						*/
/*	startadr: start address;  endadr : end address;		*/
/****************************************************************/
void dacommand( segadr , startadr , endadr )
unsigned short segadr;
unsigned long  startadr;
unsigned long  endadr;
{
	char code;	/* dump character	*/
	int i;		/* end of line      */
	char *radr;	/* memory data		*/
	unsigned long count;
	long dmpcnt;

	Hold_cmd = DACMD;               /* save command No. */
	dmpcnt=endadr-startadr+1;       /* get dump count */
	if(startadr>endadr)
		dmpcnt=(0xFFFFffffL -startadr +1)+endadr+1;

	radr = (char *)startadr;
	i = 0;		/* dump from start to end	*/
	count = startadr;

	while(dmpcnt>0){
	    if (i == 0) {		/* out address on line head	*/

		hexoutl((int)radr);  	/* output address */
		strout("  ");
		}
		code = *radr & 0x7f;	/* get data. mask msb. 	*/
		if ((code<=0x7e)&&(code>=0x20))	/* displeyable data?	*/
			chout(code);
		else
			chout('.');	/* change undiplayable data to '.' */
		i++;
		if (i == CNT_DALINE) {	/* end of line	*/
			crlfout();
			i = 0;
		}
		else if (count == endadr) 	/* cr end of all */
			chout('\n');
		if (wait_s() == CONTROL_C)
			return;
		radr++;
		count++;
		--dmpcnt;		/* dump count decriment */
	}
}

/************************************************************************/
/*	display command							*/
/*	segadr : segment						*/
/*	startadr : start address;  endadr : end address 		*/
/************************************************************************/
void dbcommand( segadr , startadr , endadr )
unsigned short segadr;
unsigned long  startadr;
unsigned long  endadr;
{
	char code;
	char *radr;
	unsigned long count;
	long dmpcnt;
	int ofset;

	Hold_cmd = DBCMD;                   /* save command No. */
	dmpcnt=endadr-startadr+1;           /* get dump count */
	if(startadr>endadr)
		dmpcnt=(0xFFFFffffL -startadr +1)+endadr+1;

	radr = (char *)startadr;
	ofset = 0;
	count = startadr;

	while(dmpcnt>0){
		for (ofset=0; ofset <= 15; ofset++) {	/* binary 		  */
	    	if (ofset == 0) {			/* top of display */
				hexoutl((int)radr);  	/* output address */
				strout("  "); 
			}
			if(((count+(unsigned long)ofset) >= startadr) && 
			   ((count+(unsigned long)ofset) <= endadr)) { /*inner area */
				code = *(radr+ofset);	/* get data	*/
				if (ofset == 7) {	/* 8data? 	*/
					hexoutb( code );
					chout('-');
				} else {
					hexoutb(code);
					strout(" ");
				}
			}
			else
				strout("   ");
		}
		strout(" ");
		for (ofset=0; ofset <= 15; ofset++) {	/*  repeat ASCII out */
			if((count+(unsigned long)ofset)>=(long)startadr && 
			   (count+(unsigned long)ofset)<=(long)endadr) { /*inner  */
				code = *(radr+ofset) & 0x7f;	/* get data */
						/* displayable character */
				if ((code<=0x7E)&&(code>=0x20))
					chout(code);	/* display data	*/
				else
					chout('.');	/* display "."	*/
			}
			else 
				strout(" ");
		}
		crlfout();
		if (wait_s() == CONTROL_C)
			return;
		radr   += 16;
		count  += 16;
		dmpcnt -= 16;		/* dump count 16/line */
	}
}

/************************************************************************/
/*	display command							*/
/*	startadr start address;  endadr	end address			*/
/************************************************************************/
void dwcommand( segadr , startadr , endadr )
unsigned short segadr;
unsigned long  startadr;
unsigned long  endadr;
{
	int code;
	int i;
	unsigned short *radr;
	unsigned long count;
	long dmpcnt;

	Hold_cmd = DWCMD;                  /* save command No. */
	dmpcnt=endadr-startadr+1;          /* get dump count */
	if(startadr>endadr)
		dmpcnt=(0xFFFFffffL -startadr +1)+endadr+1;
	radr = (unsigned short *)startadr;
	count = startadr;
	i = 0;		/* dump from start to end	*/

	while(dmpcnt>0){
		if (i == 0) {
				hexoutl((int)radr);  	/* output address */
			strout("  ");
		}	
		code = *radr;
		hexoutw(code);		/* display 16bit data 	*/
		strout(" ");
		i++;
		if (i == CNT_DWLINE) {		/* 8 word? */
			crlfout();
			i = 0;
		}
		else if (count == endadr) 	/* c/r end of all */
			crlfout();
		if (wait_s() == CONTROL_C)
			return;
		radr++;
		count += 2;
		dmpcnt -=2;			/* dump count 2 decriment */
	}
}

/************************************************************************/
/*	check start address & end address				*/
/*	startadr start address;  endadr  end address			*/
/*	function value	normal:NOERR					*/
/*			error:ERROR					*/
/************************************************************************/
int checkadr( startadr , endadr )
int startadr;
int endadr;
{
	int error;	/* error 	*/
									
	if (startadr > endadr) 
		return (error = ERROR);		/* start > end */
	else
		return (error = NOERR);		/* normal 	*/
}


/************************************************************************/
/*	conversion of alphabet a-z to A-Z			    	*/
/*		string string; 				    		*/
/************************************************************************/
void convstol( string )
char *string;
{
	int i;

	i = 0;
	while (string[i] != '\0' && string[i] != '\''  && string[i] != '"') {
		if (( string[i] >= 'a') && (string[i] <= 'z'))	/* convert */
			string[i] = string[i] - 0x20;
		i++;
	}
}

/************************************************************************/
/*		convert from string to numeric				*/
/*	string   string;	 *i: position of string	    		*/
/*	*num : converted number return value error flag	    		*/
/*		-- return value --					*/
/*	NOERR: 	  normal & string is continued				*/
/*	END: 	  normal & string is finished				*/
/*  	NOT: 	  only c/r						*/
/*	ERROR: 	  input error						*/
/*	HLDATA:   separator is ":"					*/
/************************************************************************/
int getnum( string , i , num )
char *string;
int  *i;
int  *num;
{
	char ch;		/* temporary save*/
	int data[10];		/* save keta */
	int k, j;
	int dataer;		/* error flag	*/
	int errf;		/* return flag */

	while (string[*i] == ' ') 	/* skip space */
		*i = *i + 1;
	k = 0;
	if (string[*i] == '\0')		/* input is only c/r */
		return  NOT;
	else {
		dataer = NOERR;
		do {
			ch = string[*i];
			if( ch==',' )	break;		/* delimiter ?	*/
			data[k] = hexconvc(ch);		/* convert 1 char */
			if (data[k] == 0xff || k > 7)	/* not hexa	*/
				dataer = ERROR;		/* set error */
			*i = *i + 1;
			k++;
		} while ((string[*i] != ' ') && (string[*i] != '\0') 
		      && (string[*i] != ':') && (dataer == NOERR) && (string[*i] != '-'));	
					/*until space or error*/
		if (dataer == ERROR)	/* error */
			return ERROR;
		else {			/* get number */
			*num = 0;
			for (j = 0; j <= k-1; j++) { 	/* get number	*/
				*num = *num * 16 + data[j];
			}
			if (dataer == NOERR  &&  string[*i] == ' ') {
						/* skip space or comma	*/
				while (string[*i] == ' ')
					*i = *i + 1;
				if (string[*i] == '\0')
				 	errf = END;
				else
					errf = NOERR;	/* no error	*/
			} else if (dataer == NOERR && string[*i] == ':') {
				*i = *i + 1;
				errf = HLDATA;
			} else if (dataer == NOERR && string[*i] == '-') {
				*i = *i + 1;		/* next pos. */
				errf = HLDATA;
			} 
			else if (dataer == NOERR && string[*i] == '\0')
				errf = END;	/* data end	*/
			else
				errf = NOERR;	/* other OK	*/
		}
	if (errf == HLDATA && k > 4) errf = ERROR;
	return errf;
	}
}


/************************************************************************/
/*	convert char to hexa numeric					*/
/*      char ch : input char; int hex : hexa;				*/
/*		return value : converted hexa;				*/
/************************************************************************/
int hexconvc( ch )
char ch;
{
	int hex;

	if ((ch <= '9') && (ch >= '0')) 	/* convert 0-9	*/
		hex = (int)(ch - '0');
	else if ((ch <= 'F') && (ch >= 'A'))	/* convert A-F 	*/
		hex = (int)(ch - 'A' + 10);
	else if ((ch <= 'f') && (ch >= 'a'))	/* convert a-f  */
		hex = (int)(ch - 'a' + 10);
	else					/* hex-char error*/
		hex = 0xff;			/* not 0-F 	*/
	return hex;
}

/************************************************************************/
/*	output hexa long word						*/
/*      int i : output data;						*/
/************************************************************************/
void hexoutl( i )
unsigned long i;
{
	unsigned short j;

		j = (i >> 16);	/*  high word	  */
		hexoutw( (unsigned short)j );	/*  high word  */
		hexoutw( (unsigned short)i );	/*  low word  */
}

/************************************************************************/
/*	output hexa word						*/
/*      int i : output data;						*/
/************************************************************************/
void hexoutw( i )
unsigned short i;
{
	unsigned char j;

		j = (i >> 8);	/*  high byte	  */
		hexoutb( (char)j );	/*  high byte  */
		hexoutb( (char)i );	/* low byte */
}

/************************************************************************/
/*	output hexa byte 						*/
/*      char ch  hexa byte;						*/
/************************************************************************/
void hexoutb( ch )
char ch;
{
	char ch1;

	ch1 = ch >> 4;		/*  high 4 bits  */
	hexoutc( ch1 );		/*  output high  */
	hexoutc( ch );		/*  output low   */
}


/************************************************************************/
/*	output hexa 4bits						*/
/*      char ch  hexa 4 bits;						*/
/************************************************************************/
void hexoutc( ch )
char ch;
{
	int ch1;

	ch1 = ch & 0xf;		/* mask high	*/
	if ( ch1 <= 9 ) {	/* convert 0-9	*/
		ch1=ch1+'0';
		chout( (char)ch1 );
	} else {		/* convert A-F  */
		ch1 = ch1 + 'A'-10;
		chout( (char)ch1 );
	}
}

/************************************************************************/
/* 	output error position "^Error"					*/
/*      i  error position;						*/
/************************************************************************/
void errorout( i )
int i;
{
					/* output space until error pos */
	strout("Position ERROR soft bug\n");
}

/************************************************************************/
/*  	output string							*/
/*      string[]  string;						*/
/************************************************************************/
void strout( string )
char *string;
{
	int i;

	i = 0;
	while( string[i] != '\0' ) {	/*  end of string ?	*/
		chout( string[i] );	/*  output char	*/
		i++;
	}
}

/************************************************************************/
/*  	output character						*/
/*      ch  character							*/
/************************************************************************/
void chout( ch )
char ch;
{
	if (echooff != 1) {
		kputchar(ch);
	}
}

void crlfout()
{
		kputchar(0x0a);
		kputchar(0x0d);
}

/************************************************************************/
/*		control display by ctrl_s & ctrl_q			*/
/*	check ctrl_c							*/
/*	stop between ctrl_s  ctrl_q					*/
/*	return value NOT:no input, COTROL_C:ctrl_c			*/
/************************************************************************/
int wait_s( )
{
	char ch;

	if (ch == CONTROL_C) {	/* ctrl_c */
		return CONTROL_C;
	}
	else
		return NOT;			/* no input */
}

/************************************************************************/
/*		get string						*/
/*		bb = buffer of string					*/
/*		external prflag =control flag of printer		*/
/************************************************************************/
int get_string( bb )
char *bb;
{
	int     i;
	char 	ch;

	i = 0;
	bb[i] = 0xff;
 	while (bb[i] != 0  && i < MAXSTRINGS) {
		switch(ch = kgetchar()) {	
			case CR:  	/* c/r 	*/
					bb[i]='\0';	/* set 0	*/
					chout(CR);
					chout(LF);
				   	break;
			case LF:	/* ignore l/f */
					break;
			case BS:	/* back space	*/
					if (i > 0) {
						i--;
						bb[i] = 0xff;
						strout("\b \b");
				   	}
					else if (i == 0) {
					 	bb[i] = 0xff; 
					}
				   	break;
			case TAB:	/* tab		*/
					do {
						bb[i]= ' ';
						i++;
						bb[i] = 0xff;
					} while ( i%8 != 7 );
					chout(TAB);
					break;
			case CONTROL_P:		/* ctrl_p */
					if (prflag == OFF)
						prflag = ON;	/* print on */
					else
   						prflag = OFF;	/* print off */
					break;
			case CONTROL_C:
					break;
			case CONTROL_S:
					break;
			case CONTROL_Q:
					break;
			default :	/* other char */
					bb[i] = ch;
			   		chout(ch);
					i++;
					bb[i] = 0xff;
					break;
		}
	}
	return;
}

/************************************************************************/
/*	get 32 bits address						*/
/*	string = command string;	*i = position of string  	*/
/*	*adr   = address						*/
/************************************************************************/
int get_dadr( string , i , adr )
char *string;
int  *i;
int  *adr;
{
	int errf;	/* error flag    */
	int adrl;	/* lower address work */

	errf = getnum(string,i,adr);   		/* get upper or 32bits address */
	if (errf == HLDATA) {
		errf = getnum(string,i,&adrl);	/* get lower address */
		*adr = (*adr << 16) + adrl;
		}
	return errf;
}

/************************************************************************/
/*		[E?]	Enter commands					*/
/*			E / EA / EB / EW				*/
/************************************************************************/
int enter_com( p )   
char	*p;             
{
	int	rtc;                /* return code  */

	switch( *(p+1) ){ 			/* "E?" commands*/
	  case	'A':				/* "EA"	*/
		rtc = cmdEA( p );               /* return value */
		break;
	  case	'B':				/* "EB"	*/
		rtc = cmdEB( p );               /* return value */
		break;
	  case	'W':				/* "EW"	*/
		rtc = cmdEW( p );               /* return value */
		break;
	  case  'L':
	    	rtc = cmdEL( p );
	    break;
	  case	 0:  case CR:  case LF:		/* "E"	*/
	  case ' ':  case  ',':
		rtc = cmdE( p );                /* return value */
		break;
	  default:                       	/* other error	*/
		if((*(p+1)>='0')&&(*(p+1)<='9')){
			rtc = cmdE( p );
		}else{
			strout("Command error \n");
			rtc = -1;		
		}
	}
	return( rtc );
}

/*	enter default command 		 */
int cmdE( p )
char	* p;				/*	command line strings top ptr.*/
{
	int		rtc;                

	switch( baktbl.e.cmdNo ){
	  case	CMD_EA:			/* last command : EA	*/
		rtc = cmdEA( p );
		break;
	  case	CMD_EW:			/* last command : EW	*/
		rtc = cmdEW( p );
		break;
	  case	CMD_EL:			/* last command : EL	*/
		rtc = cmdEL( p );
		break;
	  case	CMD_EB:			/* last command : EB or non*/
	  default:
		rtc = cmdEB( p );
		break;
	}
	return( rtc );               /* return */
}

/****************************************************************
		[EA]	Enter Ascii stings
*****************************************************************/
int cmdEA( p )	
char	* p;
{
	long	ps=0L;		/* enter addr		*/
	long	pl=0L;		/* data list addr	*/
	long	flg=0L;		/* address input flag (0:non 1:input)*/
	long	dmy4=0L;	/* dummy addr		*/
	char  * pb;             /* byte pointer */

	                        /* parameter decord	*/
	if( prmDecord( CMD_EA , p , &ps , &pl , &flg , &dmy4 ) == 0 ){
						/* parameter OK ?	*/
		Hold_cmd = EACMD;       	/* save command No. */
		baktbl.e.cmdNo = CMD_EA;	/* backup cmmand No	*/
		if( (long)flg == (long)0 ){	/* start prt nothing ?	*/
			ps = baktbl.e.pxbp;	/* load before ptr	*/
		}else{
			baktbl.e.pxbp  = ps;	/* save ptr		*/
		}

		cmdEAproc( (char *)ps , (char *)pl );	/* enter proc	*/
		pb = (char *)baktbl.e.pxbp; /* get next pointer */
		--pb;                       /* last pointer */
		                            /* return is byte of last */
		return( (int)((unsigned char)*pb) ); 
	}
	return( (-1) );                 /* error return */
}

void cmdEAproc( ps , pl )
char	* ps;
char	* pl;
{
	short		cnt;			/* list data counter	*/

	if( pl != 0 ){				/* data list enter	*/
		for( cnt=0 , ++pl		/* pl : skip " or ' char*/
			 ; (*pl!=0)&&(*pl!=CR)&&(*pl!=LF) ; ++pl , ++cnt ){

			*(ps+cnt) = *pl;	/* store data	*/
		}
		baktbl.e.pxbp = (long)(ps+cnt);		/* save pointer	*/
	}else{
		while(1){
			hexoutl((long)ps); 	strout(" "); hexoutb((char)*ps); strout(" ");
			bffent[0]=0;			/* buffer init. */
			get_string(bffent);		/* key input */
			if( bffent[0] == 0 ){		/* C/R only ?  */
				++ps;
			}else{				/* char. input */
			  if(bffent[0] == '-' ) { 
				--ps;
			  }else{
				if( bffent[0] == '.' ){	/* enter end chara ?*/
					baktbl.e.pxbp = (long)ps;  /* save */
					break;
				}
				for( cnt=0 ; (bffent[cnt]==SPACE) ; ++cnt );
				if( (bffent[cnt]=='"')||(bffent[cnt]==0x27) ){
					for(  ++cnt
						; (bffent[cnt]!=0)&&(bffent[cnt]!=CR)&&(bffent[cnt]!=LF)
						; ++cnt ){
							*ps = bffent[cnt];
							++ps;	/* next ptr*/
					}
				}else
					strout("error\n");	/* error msg*/
			  }
			}
		}
	}
}

/****************************************************************
		[EB]	Enter Byte
*****************************************************************/
int 	cmdEB( p )	
char	* p;
{
	long	ps=0L;			/* enter addr		*/
	long	pl=0L;			/* data list addr	*/
	long	flg=0L;			/* address input flag (0:non 1:input)*/
	long	dmy4=0L;		/* dummy addr		*/
	char  * pb;             /* byte pointer */

	                        /* parameter decord	*/
	if( prmDecord( CMD_EB , p , &ps , &pl , &flg , &dmy4 ) == 0 ){
	                        /* parameter OK ?	*/
		Hold_cmd = EBCMD;       /* save command No. */
		baktbl.e.cmdNo = CMD_EB;    /* backup cmmand No	*/
		if( (long)flg == (long)0 ){	/* start prt nothing ?	*/
			ps = baktbl.e.pxbp;     /* load before ptr	*/
		}else{
			baktbl.e.pxbp  = ps;	/* save ptr		*/
		}

		cmdEBproc( (char *)ps , (char *)pl );	/* enter proc	*/
		pb = (char *)baktbl.e.pxbp; /* get next pointer */
		--pb;                       /* last pointer */
		                            /* return byte of last pointer */
		return( (int)((unsigned char)*pb) );
	}
	return( (-1) );                 /* error return */
}

void cmdEBproc( ps , pl )
char	* ps;
char	* pl;
{
	short		cnt;		/* list data counter	*/
	int		dt;		/* convert data		*/

	if( pl != 0 ){			/* list data enter	*/
		for( cnt=0 ; (dbtbl.cnt>cnt) ; ++cnt ){

			*(ps+cnt) = dbtbl.db[cnt];	/* store data	*/
		}
		baktbl.e.pxbp = (long)(ps+cnt);		/* save pointer	*/
	}else{
		while(1){
			hexoutl((long)ps); strout(" "); hexoutb((char)*ps); strout(" ");
			bffent[0]=0;			/* buffer init. */
			get_string(bffent);		/* key input    */
			if( bffent[0] == 0 ){	/* C/R only ?	*/
				++ps;				/* ptr up*/
			}else{					/* data input	*/
			  if( bffent[0] == '-') {
			    --ps;
			  }else{
									/* space cut	*/
				for( cnt=0 ; (bffent[cnt]==SPACE) ;++cnt );
				if( bffent[cnt] == '.' ){	/* end chara ?*/
					baktbl.e.pxbp = (long)ps;  /* save */
					break;
				}
				if(isHexStr(&bffent[cnt])==0){  /* Hex char ?*/
							/* convert Hex	*/
						if( convHex( &bffent[cnt] , &dt ) == 0 ){
							if( (dt>(int)0xff)||(dt<(int)0) ){
								strout("error\n");	/* error message	*/
							}else{
								*ps = (char)dt;
								++ps;  /* next*/
							}
						}else{
							strout( "error\n");	/* error message	*/
						}
				}else{
					strout( "error\n" );	/* error msg*/
				}
			  }
			}
		}
	}
}

/****************************************************************
		[EW]	Enter Word
*****************************************************************/
int 	cmdEW( p )
char	* p;
{
	long	ps=0L;		/* enter addr		*/
	long	pl=0L;		/* data list addr	*/
	long	flg=0L;		/* address input flag (0:non 1:input)*/
	long	dmy4=0L;	/* dummy addr		*/
	short  * pw;	    	/* word pointer 1994.02.09 */

	                       	/* parameter decord	*/
	if( prmDecord( CMD_EW , p , &ps , &pl , &flg , &dmy4 ) == 0 ){
						/* parameter OK ?	*/
		Hold_cmd = EWCMD;       /* save command No. */
		baktbl.e.cmdNo = CMD_EW;	/* backup cmmand No	*/
		if( (long)flg == (long)0 ){	/* start prt nothing ?	*/
			ps = baktbl.e.pxbp;	/* load before ptr	*/
		}else{
			baktbl.e.pxbp  = ps;	/* save ptr		*/
		}

		cmdEWproc( (short *)ps , (char *)pl );	/* enter proc	*/
	    pw = (short *)baktbl.e.pxbp;    /* get next pointer 1994.02.09 */
	    --pw;                           /* last pointer 1994.02.09 */
                               /* return is word of last pointer 1994.02.09 */
        return( (int)((unsigned short)*pw) );    /* 1994.02.09 */
	}
	return( (-1) );            /* error return 1994.02.09 */
}

void cmdEWproc( ps , pl )
short	* ps;
char	* pl;
{
	short		cnt;		/* list data counter	*/
	int		dt;		/* convert data		*/
	long mps;

	if( pl != 0 ){			/* list data enter	*/
		for( cnt=0 ; (dwtbl.cnt>cnt) ; ++cnt ){

			*(ps+cnt) = dwtbl.dw[cnt];	/* store data	*/
		}
		baktbl.e.pxbp = (long)(ps+cnt);	/* save pointer	*/
	}else{
	    mps = (long)ps;
	    mps = (long)mps & (long)0xfffffffe;
	    ps  = (short *)mps;
		while(1){
			hexoutl((long)ps); strout(" "); hexoutw((short)*ps); strout(" ");
			bffent[0]=0;                	/* buffer init.  */
			get_string(bffent);         	/* key input     */
			if( bffent[0] == 0 ){           /* C/R only ?*/
				++ps;   		/* ptr up*/
			}else{                          /* data input*/
			  if( bffent[0] == '-') {
			  	--ps;   		/* ptr down */
			  }else{		 	/* space cut */
				for( cnt=0 ; (bffent[cnt]==SPACE) ;++cnt );
				if( bffent[cnt]=='.' ){         /* enter end chara ?*/
					baktbl.e.pxbp = (long)ps;   /* save */
					break;
				}
				if(isHexStr(&bffent[cnt])==0){	/* Hex char ?*/
							/* convert Hex	*/
						if( convHex( &bffent[cnt] , &dt ) == 0 ){
							if( (dt>(int)0xffff)||(dt<(int)0) ){
								strout("error\n");	/* error message*/
							}else{
								*ps = (short)dt;	/* store data		*/
								++ps;  /* next*/
							}
						}else{
							strout( "error\n");	/* error message	*/
						}
				}else{
					strout("error\n");	/* error msg*/
				}
			  }
			}
		}
	}
}

/****************************************************************
		[EL]	Enter long Word
*****************************************************************/
int 	cmdEL( p )
char	* p;
{
	long	ps=0L;		/* enter addr		*/
	long	pl=0L;		/* data list addr	*/
	long	flg=0L;		/* address input flag (0:non 1:input)*/
	long	dmy4=0L;	/* dummy addr		*/
	long  * lp;	    	/* long pointer 	*/

	                       	/* parameter decord	*/
	if( prmDecord( CMD_EL , p , &ps , &pl , &flg , &dmy4 ) == 0 ){
						/* parameter OK ?	*/
		Hold_cmd = ELCMD;       	/* save command No. */
		baktbl.e.cmdNo = CMD_EL;	/* backup cmmand No	*/
		if( (long)flg == (long)0 ){	/* start prt nothing ?	*/
			ps = baktbl.e.pxbp;	/* load before ptr	*/
		}else{
			baktbl.e.pxbp  = ps;	/* save ptr		*/
		}
		ps = ps & 0xfffffffc;       	/* align 4 */
		cmdELproc( (long *)ps , (char *)pl );	/* enter proc	*/
	    lp = (long *)baktbl.e.pxbp;   	/* get next pointer		*/
	    --lp;                         	/* last pointer         */
						/* return is word of last pointer */
        return( (int)((unsigned long)*lp) ); 
	}
	return( (-1) );            /* error return */
}

void cmdELproc( ps , pl )
long	* ps;
char	* pl;
{
	long	cnt;		/* list data counter	*/
	long	dt;		/* convert data		*/

	if( pl != 0 ){			/* list data enter	*/
		for( cnt=0 ; (dltbl.cnt>cnt) ; ++cnt ){
			*(ps+cnt) = dltbl.dl[cnt];	/* store data	*/
		}
		baktbl.e.pxbp = (long)(ps+cnt);	/* save pointer	*/
	}else{
		while(1){ 
			hexoutl((long)ps); strout(" "); hexoutl((long)*ps); strout(" ");
			bffent[0]=0;        		/* buffer init.  */
			get_string(bffent); 		/* key input     */
			
			if( bffent[0] == 0 ){		/* C/R only ?*/
				++ps;   		/* ptr up*/
			}else{                          /* data input*/
			  if( bffent[0] == '-') {
			  		--ps;   	/* ptr down */
				}else{                  /* data input*/
	                                            	/* space cut */
					for( cnt=0 ; (bffent[cnt]==SPACE) ;++cnt );
					if( bffent[cnt]=='.' ){         /* enter end chara ?*/
						baktbl.e.pxbp = (long)ps;   /* save */
						break;
					}
					if(isHexStr(&bffent[cnt])==0){	/* Hex char ?*/
							/* max-RAM check*/
						if( (unsigned long)ps <= (unsigned long)RAM_EMEND ){
							/* convert Hex	*/
							if( convHex( &bffent[cnt] , &dt ) == 0 ){
								*ps = (long)dt;		/* store data		*/
								++ps;  /* next*/
							}else{
								strout("error\n");	/* error message	*/
							}
						}else{
							strout( "bottom address ");
							hlprintk( ps );
							baktbl.e.pxbp = (long)ps;	/* save pointer		*/
							break;
						}
					}else{
						strout("error\n");	/* error msg*/
					}
				}
			}
		}
	}
}
/*****************************************************************
		[F]		Fill memory
******************************************************************/
int 	fill_com( p ) 
char	*	p;   
{
	convstol(p);		/* small letter to upper */
	return( cmdF( p ) );    /* return 1994.02.09 */
}

int 	cmdF( p )
char	* p;
{
	long	ps;	/* start pointer		*/
	long	pe;	/* end pointer			*/
	long	dt;	/* fill data(patern)	*/
	long	dmy4;	/* dummy addr			*/
			/* parameter decord	*/
	if( prmDecord( CMD_F , p , &ps , &pe , &dt , &dmy4 ) == 0 ){
		Hold_cmd = FCMD; 
		cmdFproc( (char *)ps , (char *)pe , (unsigned char)dt );
		return( (int)((unsigned char)dt) );
	}
	return( (-1) );
}

void cmdFproc( ps , pe , dt )
char             * ps;
char             * pe;
unsigned char      dt;
{
	while( ps < pe ){
		*ps = (char)dt;			/* fill data	*/
		++ps;
	}
	*ps = (char)dt;				/* last ptr	*/
}



/****************************************************************
		[M]		move memory
*****************************************************************/
int 	mcopy_com( p )
char	*	p;
{
	convstol(p);		/* small letter to upper */
	return( cmdM( p ) );    /* return 1994.02.09 */
}

int 	cmdM( p )
char	* p;
{
	long	ps=0;		/* source top addr	*/
	long	pe=0;		/* source end addr	*/
	long	pd=0;		/* destination addr	*/
	long	dmy4=0;		/* dummy addr		*/

	                        /* parameter decord	*/
	if( prmDecord( CMD_M , p , &ps , &pe , &pd , &dmy4 ) == 0 ){
		Hold_cmd = MCMD;            /* save command No. 1994.02.09 */
		return( cmdMproc( (char *)ps , (char *)pe , (char *)pd ) );
	}
	return( (-1) );         /* error return 1994.02.09 */
}

int 	cmdMproc( ps , pe , pd ) 
char	* ps;
char	* pe;
char	* pd;
{
	unsigned long  sz;      /* move byte size	*/
	char	* pde;          /* distinate end ptr	*/
	char     rtc;           /* return code 1994.02.09 */

	sz = ((unsigned long)pe - (unsigned long)ps +1);		/* move size	*/
	pde = (pd + (sz-1));			/* distinate end ptr	*/
	if( ps!=pd ){				/* diferent(unmatch) area ?*/
		if( (ps<pd)&&(pd<pe) ){		/* pe-->ps copy to pde-->pd*/
			while( (ps != pe)&&(pd != pde) ){	/* continue ?*/
				*pde = *pe;		/* 1 byte move	*/
				--pe;
				--pde;
			}
			*pde = *pe;		/* last 1 byte move*/
			 rtc = *pde;    /* return value 1994.02.09 */
		}else{			/* ps-->pe copy to pd-->pde	*/
			while( (pe != ps)&&(pde != pd) ){	/* continue ?*/
				*pd = *ps;		/* 1 byte move	*/
				++ps;
				++pd;
			}
			*pd = *ps;         /* last 1 byte move	*/
			 rtc = *pd;        /* return value set 1994.02.09 */
		}
	}
	return( (int)((unsigned char)*pd) );    /* return 1994.02.09 */
}



/***************************************************
		added command help
****************************************************/
void help_msg( )
{

	strout("\n  D[type] [<range>]                -- dump memory\n");
	strout("  E[type] [<address>] [<list>]     -- enter memory\n");
	strout("  F <range> <value>                -- fill memory\n");
	strout("  M <range> <address>              -- move memory\n");
}

/*********************************************************
		prmDecord	: Parameter decord
**********************************************************/
int prmDecord( typ , p , p1 , p2 , p3 , p4 )	
short typ;
char * p;
long * p1, * p2, * p3, * p4;	
{
	char	* pd;			/* decord position(ptr)		*/
	short	  prmcnt;		/* data(parameter) count	*/
	int		  rtc;		/* return code			*/
	short	  idx;			/* index of command name table	*/

	rtc = 0;
	switch( typ ){
	  case	CMD_DA:				/*  3 : Dump Ascii	*/
	  case	CMD_DB:				/*  4 : Dump byte	*/
	  case	CMD_DW:				/*  5 : Dump word	*/
	  case	CMD_D :				/*  6 : Dump		*/
		break;
	  case	CMD_EA:				/*  7 : Enter Ascii	*/
		*p3 = 0L;			/* addr. input flag OFF	*/
		*p2 = 0L;			/* initial list nothing	*/
		*p1 = 0L;			/* initial addr. nothing*/
		pd=p;				/* 1st param. pos	*/
		if((*pd=='E')||(*pd=='e'))	++pd;	/* 'E' char. skip*/
		if((*pd=='A')||(*pd=='a'))	++pd;	/* 'A' char. skip*/
		for( ; *pd==SPACE ; ++pd );		/* space cut	*/
		if( (*pd==0)||(*pd==LF)||(*pd==CR) )
			break;			/* parameter nothing*/
		if( *pd!=COMMA ){		/* 1st param. exist	*/
						/* 1st param. data	*/
			if( (rtc=prmDecordData(pd,p1,DT_HEX))!=0 )	break;
			*p3 = (long)0x00000001;		/* addr. exist ON*/
			for( ; (*pd!=SPACE)&&(*pd!=COMMA)
				&&(*pd!=0)&&(*pd!=CR)&&(*pd!=LF) ; ++pd );
		}
						/*  2nd param pos	*/
		if(*pd==COMMA)	++pd;		/* 1st comma skip	*/
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==0)||(*pd==CR)&&(*pd==LF) )
			break;			/* 2nd nothing	*/
		if( (*pd!=COMMA) ){		/* 2nd param. exist	*/
			if( (*pd=='"')||(*pd==0x27) ){	/* top char " or '*/
				*p2 = (long)pd;		/* list ptr exist*/
				break;
			}else{
				rtc = -1;		/* error	*/
			}
		}
		break;
	  case	CMD_EB:			/*  8 : Enter Byte		*/
	  case	CMD_EW:			/*  9 : Enter Word		*/
	  case  CMD_EL:         /* 10 : Enter long      */
		*p3 = 0L;			/* addr. input flag OFF	*/
		*p2 = 0L;			/* initial list nothing	*/
		*p1 = 0L;			/* initial addr. nothing*/
		pd=p;				/* 1st param. pos	*/
		if((*pd=='E')||(*pd=='e'))
			++pd;			/* 'E' char. skip	*/
		if((*pd=='B')||(*pd=='b')||(*pd=='W')||(*pd=='w')||(*pd=='L')||(*pd=='l'))
			++pd;			/* 'B'or'W' char. skip*/
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==0)||(*pd==LF)||(*pd==CR) )
			break;			/* parameter nothing*/
		if( *pd!=COMMA ){		/* 1st param. exist	*/
						/* 1st param. data	*/
			if( (rtc=prmDecordData(pd,p1,DT_HEX))!=0 )	break;
			*p3 = (long)0x00000001;		/* addr. exist ON*/
			for( ; (*pd!=SPACE)&&(*pd!=COMMA)
				&&(*pd!=0)&&(*pd!=CR)&&(*pd!=LF) ; ++pd );
		}
						/*  2nd param pos	*/
		if(*pd==COMMA)	++pd;		/* 1st comma skip	*/
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==0)||(*pd==CR)&&(*pd==LF) )
			break;			/* 2nd nothing	*/
		if( (*pd!=COMMA) ){		/* 2nd param. exist	*/
			*p2=(long)pd;		/* list data prt	*/
			if( typ == CMD_EB ){
				if((rtc=convListB(pd,&dbtbl.db[0],&dbtbl.cnt))!=0)
				break;
			}
			if( typ == CMD_EW){
				if((rtc=convListW(pd,&dwtbl.dw[0],&dwtbl.cnt))!=0)
				break;
			}
			if( typ == CMD_EL){
				if((rtc=convListL(pd,&dltbl.dl[0],&dltbl.cnt))!=0)
				break;
			}
		}else{				/* list data error	*/
			rtc = -1;
		}
		break;

	  case	CMD_E :				/* 11 : Enter		*/
		break;
	  case	CMD_F :				/* 12 : Fill memory	*/
		*p3 = 0L;			/* initial fill code	*/
		*p2 = 0L;			/* initial size nothing	*/
		*p1 = 0L;			/* initial addr. nothing*/
		pd=p+1;				/* 1st param. pos	*/
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==COMMA)||(*pd==0)||(*pd==LF)||(*pd==CR) ){
			rtc = -1;		/* start addr. error*/
			break;			/* parameter nothing*/
		}
						/* 1st param. data	*/
		if( (rtc=prmDecordData(pd,p1,DT_HEX))!=0 ){
			break;			/* convert error	*/
		}
						/*  2nd param pos	*/
		for( ; (*pd!=SPACE)&&(*pd!=COMMA)
			&&(*pd!=0)&&(*pd!=CR)&&(*pd!=LF) ; ++pd );
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==COMMA) )	++pd;	/* 1st comma skip	*/
		for( ; *pd==SPACE ; ++pd );
		if( (*pd==0)||(*pd==LF)||(*pd==CR) ){
			rtc = -1;		/* end addr. error	*/
			break;			/* parameter nothing*/
		}
						/* 2nd param. data	*/
		if( (rtc=prmDecordData(pd,p2,DT_HEX))!=0 ){
			break;
		}
		if( *p1 > *p2 ){		/* start and end addr.*/
			rtc = -1;		/* start > end : error*/
			break;
		}
						/*  3rd param pos	*/
		for( ; (*pd!=SPACE)&&(*pd!=COMMA)
			&&(*pd!=0)&&(*pd!=CR)&&(*pd!=LF) ; ++pd );
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==COMMA) )	++pd;	/* 2nd comma skip	*/
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==COMMA)||(*pd==0)||(*pd==LF)||(*pd==CR) ){
			rtc = -1;		/* end addr. error	*/
			break;			/* parameter nothing*/
		}
						/* char. or hex-code	*/
		if( (*pd=='"')||(*pd==0x27) ){	/* 1 chara data ?	*/
			++pd;			/* data ptr		*/
			*p3=(long)*pd;		/* set ASCII	*/
			++pd;
			if( (*pd!=SPACE)&&(*pd!=0)&&(*pd!=LF)&&(*pd!=CR) )
				rtc = -1;	/* too param. error	*/
		}else{				/* 1 byte hex data	*/
			rtc = prmDecordData( pd , p3 , DT_HEX  );
		}
		break;
	  case	CMD_M :			/* 12 : Move memory		*/
		*p3 = 0L;			/* initial dest. ptr	*/
		*p2 = 0L;			/* initial range end	*/
		*p1 = 0L;			/* initial range top	*/
		pd=p+1;				/* 1st param. pos	*/
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==COMMA)||(*pd==0)||(*pd==LF)||(*pd==CR) ){
			rtc = -1;		/* start addr. error*/
			break;			/* parameter nothing*/
		}
						/* 1st param. data	*/
		if( (rtc=prmDecordData(pd,p1,DT_HEX))!=0 ){
			break;			/* convert error	*/
		}
						/*  2nd param pos	*/
		for( ; (*pd!=SPACE)&&(*pd!=COMMA)
			&&(*pd!=0)&&(*pd!=CR)&&(*pd!=LF) ; ++pd );
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==COMMA) )	++pd;	/* 1st comma skip	*/
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==0)||(*pd==LF)||(*pd==CR) ){
			rtc = -1;		/* end addr. error	*/
			break;			/* parameter nothing*/
		}
						/* 2nd param. data	*/
		if( (rtc=prmDecordData(pd,p2,DT_HEX))!=0 ){
			break;
		}
						/* range check (top<=end) */
		if( (unsigned long)*p1>(unsigned long)*p2 ){
			rtc = -1;		/* top > end error	*/
			break;
		}
						/*  3rd param pos	*/
		for( ; (*pd!=SPACE)&&(*pd!=COMMA)
			&&(*pd!=0)&&(*pd!=CR)&&(*pd!=LF) ; ++pd );
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==COMMA) )	++pd;	/* 2nd comma skip	*/
		for( ; *pd==SPACE ; ++pd );	/* space cut		*/
		if( (*pd==COMMA)||(*pd==0)||(*pd==LF)||(*pd==CR) ){
			rtc = -1;		/* end addr. error	*/
			break;			/* parameter nothing*/
		}
		rtc = prmDecordData( pd , p3 , DT_HEX  );
		break;

	  default:				/* parameter error	*/
		rtc = -1;
	}
						/* paramter error MSG.	*/
	if( rtc != 0 ){
	    /*
		for( idx=0
			 ;(cmdnmtbl[idx].cmd!=CMD_EOC)&&(cmdnmtbl[idx].cmd!=typ)
			 ; ++idx );
		*/
		strout("Error \n");;		/* error message	*/
	}
	return( rtc );
}

short	prmDecordData( p , pd , typ )
char	* p;
long	* pd;
short	typ;
{
	short			rtc;

	rtc = 0;
	switch( typ ){
	  case	DT_HEX:
	  case	DT_DEC:
	  case	DT_NUM:
		rtc = convHex( p , pd );	/* Hex-decimal conversion	*/
		break;
	  case	DT_ASC:
		*pd = (long)p;			/* non conversion	*/
		break;
	  case	DT_AN:
		*pd = (long)p;			/* non conversion	*/
		break;
	  default:
		break;
	}
	return( rtc );
}

short	convListB( p , pt , pcnt )
char	* p;
char	* pt;
short	* pcnt;
{
	short	  rtc=0;
	long	  dt;

	for( ; *p==SPACE ; ++p);			/* space cut	*/
	if( *p==COMMA )	++p;				/* comma skip	*/
	for( ; *p==SPACE ; ++p);			/* space cut	*/
	for( *pcnt=0 ; (*p!=0)&&(*p!=CR)&&(*p!=LF) ; ){
		if( convHex( p , &dt ) == 0 ){
			++*pcnt;			/* count up	*/
			*pt=(char)dt;			/* store convert data	*/
			++pt;				/* next table		*/
			for( ; (*p!=SPACE)&&(*p!=COMMA)	/* next str	*/
					&&(*p!=0)&&(*p!=CR)&&(*p!=LF) ; ++p );
			for( ; *p==SPACE ; ++p);	/* space cut	*/
			if( *p==COMMA )	++p;		/* comma skip	*/
			for( ; *p==SPACE ; ++p);	/* space cut	*/
		}else{
			rtc = -1;			/* set convert error	*/
			break;
		}
	}

	return( rtc );
}

short	convListW( p , pt , pcnt )
char	* p;
short	* pt;
short	* pcnt;
{
	short		  rtc=0;			/* initial : OK	*/
	long		  dt;

	for( ; *p==SPACE ; ++p);			/* space cut	*/
	if( *p==COMMA )	++p;				/* comma skip	*/
	for( ; *p==SPACE ; ++p);			/* space cut	*/
	for( *pcnt=0 ; (*p!=0)&&(*p!=CR)&&(*p!=LF) ; ){
		if( convHex( p , &dt ) == 0 ){
			++*pcnt;			/* count up	*/
			*pt=(short)dt;			/* store convrt data*/
			++pt;				/* next table		*/
			for( ; (*p!=SPACE)&&(*p!=COMMA)		/* next str	*/
					&&(*p!=0)&&(*p!=CR)&&(*p!=LF) ; ++p );
			for( ; *p==SPACE ; ++p);	/* space cut	*/
			if( *p==COMMA )	++p;		/* comma skip	*/
			for( ; *p==SPACE ; ++p);	/* space cut	*/
		}else{
			rtc = -1;			/* set convert error*/
			break;
		}
	}

	return( rtc );
}

short	convListL( p , pt , pcnt )
char	* p;
long	* pt;
long	* pcnt;
{
	short	  rtc=0;				/* initial : OK	*/
	long	  dt;

	for( ; *p==SPACE ; ++p);			/* space cut	*/
	if( *p==COMMA )	++p;				/* comma skip	*/
	for( ; *p==SPACE ; ++p);			/* space cut	*/
	for( *pcnt=0 ; (*p!=0)&&(*p!=CR)&&(*p!=LF) ; ){
		if( convHex( p , &dt ) == 0 ){
			++*pcnt;			/* count up	*/
			*pt=(short)dt;			/* store convrt data*/
			++pt;				/* next table		*/
			for( ; (*p!=SPACE)&&(*p!=COMMA)	/* next str	*/
					&&(*p!=0)&&(*p!=CR)&&(*p!=LF) ; ++p );
			for( ; *p==SPACE ; ++p);	/* space cut	*/
			if( *p==COMMA )	++p;		/* comma skip	*/
			for( ; *p==SPACE ; ++p);	/* space cut	*/
		}else{
			rtc = -1;			/* set convert error*/
			break;
		}
	}
	return( rtc );
}


short	convHex( p , pd )
char	* p;
long	* pd;
{
	int	val , val1;
	short	num;
	int	i;
	short	rtc=0;		/* initial return code : 0(OK)	*/

	val = 0;
	i = 0;
	rtc = (short) getnum( p , &i, &val );
	if (rtc == HLDATA) {
		rtc = getnum( p , &i ,&val1 );	/* get lower address */
		val = (val << 16) + val1;
	}
	if( rtc==END)	rtc=0;				/* OK	*/
	*pd=val;
	return( rtc );
}

short	isHexStr( p )
char	* p;
{
	short		rtc=0;

	for(  ; (*p!=NULL)&&(*p!=CR)&&(*p!=LF) ; ++p ){
		if( (*p>='a')&&(*p<='f') ){
			*p -= 0x20;			/* large alphabette	*/
		}
		if( ! (  ((*p>='0')&&(*p<='9'))
			   ||((*p>='A')&&(*p<='F'))  ) ){
			rtc = -1;		/* error */
			break;
		}
	}
	return( rtc );
}

#if 0
/*********************************************************
		S format read
**********************************************************/
#define CacheThrowArea 0x00000000
static char* gStartAddrs = 0;
static char* pStartAddrs = 0;
static char* gEndAddrs;
static int gEAddrsFromSAddrs = 0xff;
static char gOption[] = "No Option";
static char gFirst = 0;

int go_cmd(void)
{
	asm("
		mov.l	@(gojp,pc),r0
		jmp		@r0
		nop
	
		.align	4
	gojp:
		.long	0x8c001000
	");
}

int mem_load(string)
char	* string;
{
	char MLBuff[100];

	gStartAddrs = 0;

	strout("Please Send A S-format Record\n");
	echooff = 1;
	gFirst = 1;
	do{
		/* kputch(0x11); */
		get_string(MLBuff);
		/* kputch(0x13); */
	} while(DecodeSFormat(MLBuff));
	/* kputch(0x11); */
	strout("Record end \n");
	echooff = 0;
}

int DecodeSFormat(Ptr)
	char* Ptr;
{
	char AsciiTemp[9];
	unsigned char ByteCount;
	int i;

	int Data;
	char* VerifyAddrs;

	if(Ptr[0] != 's' && Ptr[0] != 'S'){
		strout("Only S-format!\n");
		strout(Ptr); strout("\n");
		return(0);
	}

	AsciiTemp[0] = Ptr[2];
	AsciiTemp[1] = Ptr[3];
	AsciiTemp[2] = '\0';
	ByteCount = strtol(AsciiTemp,0,16);

	switch(Ptr[1]){
		case	'0':
			gFirst = 1;return(1);
		case	'1':
			for(i = 4; i < 8; i++)
				AsciiTemp[i-4] = Ptr[i];
			AsciiTemp[i-4] = '\0';
			gStartAddrs = (char*)strtol(AsciiTemp,0,16);
			ByteCount-=2;
			if(gFirst){
				(long)pStartAddrs = (long)gStartAddrs;
				gFirst = 0;
			}
			break;
		case	'2':
			for(i = 4; i < 10; i++)
				AsciiTemp[i-4] = Ptr[i];
			AsciiTemp[i-4] = '\0';
			gStartAddrs = (char*)strtol(AsciiTemp,0,16);
			ByteCount-=3;
			if(gFirst){
				(long)pStartAddrs = (long)gStartAddrs;
				gFirst = 0;
			}
			break;
		case	'3':
			for(i = 4; i < 12; i++)
				AsciiTemp[i-4] = Ptr[i];
			AsciiTemp[i-4] = '\0';
			gStartAddrs = (char*)strtol(AsciiTemp,0,16);
			ByteCount-=4;
			if(gFirst){
				(long)pStartAddrs = (long)gStartAddrs;
				gFirst = 0;
			}
			break;
		case	'7':case '8':case '9':
			strout("\nStart Addrs = ");
			hlprintk(pStartAddrs); strout("\n");
			strout("End Addrs   = ");
			hlprintk(gStartAddrs); strout("\n");
			strout("Transfer complete\n");
			gEndAddrs = gStartAddrs + 0xFF;
			gEAddrsFromSAddrs=(int)gEndAddrs - (int)gStartAddrs;
			return(0);
		default:return(1);
	}

	ByteCount = ByteCount-1;
	while(ByteCount--){
			AsciiTemp[0] = Ptr[i++];
			AsciiTemp[1] = Ptr[i++];
			AsciiTemp[2] = '\0';

 			Data =  strtol(AsciiTemp,0,16);
			*gStartAddrs = (char)Data;
			if(((int)gStartAddrs & 0xf0000000) == 0)
				VerifyAddrs = gStartAddrs+CacheThrowArea;
			else
				VerifyAddrs = gStartAddrs;
			if((char)Data != *VerifyAddrs){
				strout("Verify Error!! Error Addrs =  ");
				hlprintk(gStartAddrs); strout("\n");
				return(0);
			}
			gStartAddrs++;
	}
	return(1);
}

int strtol(char* s,char** endp,int base)
{
	int i,n;
	for(i = 0; isspace(s[i]);i++);
	for(n = 0; isxdigit(s[i]);i++){
		if( s[i] <= '9')
			n = base*n + (s[i] - '0');
		else if( s[i] <= 'F')
			n = base*n + (s[i] - '7');
		else
			n = base*n + (s[i] - 'W');			
	}
	if( endp !=0 )
		*endp = &s[i];
	return n;
}
#endif /* S format Read */

/************************************************************* End of source */
