/****************************************************************/
/*            commannd program Header file                      */
/*								*/
/* Copyright (C) 1998 Nobuhiro Sakawa				*/
/*								*/
/****************************************************************/
/***********************************/
/*     cmd.h                      */
/***********************************/


/*====	data type	=========*/

typedef		unsigned char   U_CHAR;
typedef		unsigned short  U_SHORT;
typedef		unsigned long   U_LONG;
typedef		void		VOID;
typedef		int		INT;
typedef		long		LONG;

#define TRUE  1
#define FALSE 0


#define MAXBUFF    1000
#define READ	   0
#define INSERT	   1
#define BMODE	   1
#define CMODE	   0

#define DACMD	1
#define DWCMD	2
#define DBCMD	3
#define EACMD	4
#define EWCMD	5
#define EBCMD	6
#define ELCMD   7
#define FCMD	8
#define MCMD	9


/*-------------------------
**	RAM range
**-------------------------*/
#define	RAM_TOP		0x00000000	/* 00000000h (conventional memory)*/
#define	RAM_END		0xFFFFffff	/* FFFFffffh (conventional memory)*/
#define	RAM_EMTOP	0x00000000	/* 00000000h (extended memory)	*/
#define	RAM_EMEND	0xFFFFFFFF	/* ffffffffh (extended memory)	*/

/*-------------------------*/

#define MAX_STRING	  100	/*  max of main command buffer		*/
#define	MAXSTRINGS 	  100		/*  max size of input buffer  */
#define NOERR		  0		/*  no error			*/
#define ERROR		  1		/*  error			*/
#define END		  2		/*  id of sting end 	*/
#define NOEND		  0		/*  no end			*/
#define	CONTINUE	  1
#define NOT		  4		/*  no input			*/
#define ON		  1		/*  on				*/
#define OFF		  0		/*  off				*/
#define HLDATA		  5		/*  address data 0000:0000 	*/
#define DA		  1		/*  DA command		*/
#define DB		  3		/*  DB command	*/
#define DW		  2		/*  DW comman   */
#define SET		  1		/*  flag set	*/
#define CLEAR		  0		/*	flag clear	*/
#define ENABLE		  1		/*  flag enable		*/
#define DESABLE		  0		/*	flag disable	*/
#define ADR0		  0		/*	adr mode:no	*/
#define ADR1		  1		/*            only start adr*/
#define ADR2		  2		/*  	      start & end	*/

/*====	ASCII code	=========*/
#ifndef		NULL			/* null code	*/
#define		NULL	0
#endif

#define		CR		0x0d	/* c/r		*/
#define		LF		0x0a	/* l/f		*/
#define		BS		0x08	/* BS		*/
#define		TAB		0x09	/* TAB		*/
#define		CONTROL_C	0x03	/* ctrl+C	*/
#define		CONTROL_P	0x10	/* ctrl+P	*/
#define		CONTROL_Q	0x11	/* ctrl+Q	*/
#define		CONTROL_S	0x13	/* ctrl+S	*/
#define		ESC		0x1b	/* ESC		*/
#define		SPACE		0x20	/* space char.	*/
#define		COMMA		','		/* comma char.	*/

/*====  dump size or count  =====*/
#define		SZ_DADEF	0xC0	/* DA : default size */
#define		SZ_DBDEF	0x80	/* DB : default size */
#define		SZ_DWDEF	0x80	/* DW : default size */
#define		CNT_DALINE	0x30	/* DA : char/line */
#define		CNT_DBLINE	0x10	/* DB : data/line */
#define		CNT_DWLINE	0x08	/* DW : data/line */


/*====	status	=============*/
#ifndef		CHAR_RDY	/* LN16450 status : received data */
#define		CHAR_RDY	0x01
#endif

/*====	parameter decord type	=====*/

#define		DT_ASC		(0x01)	/* alphabet type	*/
#define		DT_HEX		(0x10)	/* hex-decimal type	*/
#define		DT_DEC		(0x20)	/* hex-decimal type	*/
#define		DT_NUM	(DT_HEX|DT_DEC)	/* hex-decimal type	*/
#define		DT_AN	(DT_ASC|DT_NUM)	/* alpha-numeric type	*/

/*====	command type	=============*/

#define		CMD_DA	0x0301		/* command No.	01	DA	*/
#define		CMD_DB	0x0302		/* command No.	02	DB	*/
#define		CMD_DW	0x0303		/* command No.	03	DW	*/
#define		CMD_D	0x0304		/* command No.	04	D	*/
#define		CMD_EA	0x0401		/* command No.	05	EA	*/
#define		CMD_EB	0x0402		/* command No.	06	EB	*/
#define		CMD_EW	0x0403		/* command No.	07	EW	*/
#define		CMD_EL	0x0404		/* command No.	08	EW	*/
#define		CMD_E	0x0405		/* command No.	09	E	*/
#define		CMD_F	0x0501		/* command No.	10	F	*/
#define		CMD_M	0x0601		/* command No.	11	M	*/
#define		CMD_EOC	0x0E0C		/* command No.	End of Code	*/

/* addcmd.c procedures */

void convstol( );
void getdmp_adr( );
void seldmpcom( );
void Setdadr2( );
void Setdadr1( );
void Setdadr0( );
void dacommand( );
void dbcommand( );
void dwcommand( );
int  checkadr( );
void errorout( );
void hexoutl( );
void hexoutw( );
void hexoutb( );
void hexoutc( );
void strout( );
void chout( );
void crlfout();
void prout( );
int  wait_s( );
void get_str( );
int  get_string();
char chin( );

void hcommand( );
void hexoutd( );
	                    /*-No-CMD--CMD description------*/

int     cmdEA(  );      /*   EA : Enter Ascii		*/
int     cmdEB(  );      /*   EB : Enter Byte		*/
int     cmdEW(  );      /*   EW : Enter Word		*/
int     cmdEL(  );      /*   EL : Enter Word		*/
int     cmdE (  );      /*   E  : Enter                */
int     cmdF (  );      /*   F  : Fill memory		*/
int     cmdM (  );      /*   M  : Move memory		*/

				/* Enter Ascii	*/
VOID	cmdEAproc(  );
				/* Enter Byte	*/
VOID	cmdEBproc(  );
				/* Enter Word	*/
VOID    cmdEWproc(  );
				/* Enter Long	*/
VOID    cmdELproc(  );
				/* Fill memory	*/					
VOID	cmdFproc(  );
				/* Move memory	*/
int 	cmdMproc(  );
				/* parameter decord	*/
					
					
INT     prmDecord(  );
				/* decord data		*/
short	prmDecordData (  );
				/* convert Hex-decimal	*/
short	convHex(  );
				/* Hex-decimal strings check*/
short	isHexStr(  );
				/* convert list data	*/
short	convListB(  );
short	convListW(  );
short	convListL(  );
				/* process wait while 1 sec.*/
short	waitProc(   );

/*-----------------------------------*
**	for main()
**-----------------------------------*/
int 	dump_com( );		/* command : 'D?'	*/
int 	enter_com( );		/* command : 'E?'	*/
int 	fill_com( );		/* command : 'F'	*/
int 	mcopy_com( );		/* command : 'M'	*/
void	help_msg();		/* command : '?'    	*/
extern void	hd_boot();	/* command : 'b'	*/
extern void	cd_boot();	/* command : 'c' 	*/

/***************************************
**		command name table
****************************************/
#define		MAX_CMDTBL	16		/* command table count max. */

struct	_cmdnmtbl{
		short	cmd;
};
struct	_cmdnmtbl	*cmdnmtbl;	/* command name  table	*/


/***************************************
**	added command help MSG table
****************************************/
#define	MAX_HELPMSG	16		/* help MSG count max. */
char	* addmsgtbl;			/* added command help MSG */

/***************************************
**	back up table
****************************************/
struct	_backfmt{
		short	 cmdNo;			/* command No.	*/
		long	 pxbp;			/* last byte ptr*/
		long	 pxwp;			/* last word ptr*/
		long     pxlp;			/* last long ptr*/
};
struct	_baktbl{
		struct	_backfmt	d;	/* command D	*/
		struct	_backfmt	e;	/* command E	*/
};
	struct	_baktbl		baktbl;		/* external declaration	*/

/****************************************
**		convert data table
****************************************/
#define		MAX_CNVDATA	128		/* convert count max. */

struct	_dbtbl{					/* byte data table	*/
		short	cnt;			/* data couny		*/
		char	db[MAX_CNVDATA];	/* convert data list*/
};
struct	_dwtbl{					/* word data table	*/
		short	cnt;			/* data couny		*/
		short	dw[MAX_CNVDATA];	/* convert data list*/
};
struct	_dltbl{					/* word data table	*/
		short	cnt;			/* data couny		*/
		long	dl[MAX_CNVDATA];	/* convert data list*/
};

	struct	_dbtbl	dbtbl;		/* convert byte data table	*/
	struct	_dwtbl	dwtbl;		/* convert byte data table	*/
	struct  _dltbl  dltbl;

/****************************************
**		key input buffer
****************************************/
#define		SZ_ENTBFF	128		/* step input buffer length */

	char	 bffent[SZ_ENTBFF];		/* data input buffer	*/

	int	Hold_cmd;	/* requested command No. */

/******************************************************** End of header	*/
