/************************************************************
  getchar / putchar 
  Copyright (C) 2001 Nobuhiro Sakawa
  Date: 2001/01/01
  Revision: 1.0 $
*************************************************************/
#include "sh.h"
#include "config.h"
#define	SEM_ID0		0

/********************************************************************/
/*	input char						*/
/*      return value  input char				*/
/********************************************************************/
char getrc;

#if 0 /* SCI */
void recverr(void) /* SCI1 receive error vector address 0x1a0 */
{
		SCI_SCSSR &= 0xc4;
}
void receive(void) /* SCI1 receive interrupr vector address 0x1a4*/
{

        while(!(SCI_SCSSR & SCI_RDRF));

		if (( SCI_SCSSR & 0x38) != 0)
				SCI_SCSSR &= 0xc4; /* test '98/01/22 */
		getrc = SCI_SCRDR;
		SCI_SCSSR = SCI_SCSSR &~SCI_RDRF;
}

/* ap key read */

char _kgetchar( )	
{
	char rc;
	
    receive();
	rc = getrc;
	return rc;
}

/* put char */

int kputch(c) 
int c;
{

    int i;

    while(!(SCI_SCSSR & SCI_TDRE));
    SCI_SCTDR = c;
    SCI_SCSSR = SCI_SCSSR & ~SCI_TDRE;
    return c;

}


_kputchar(c)
int c;
{
    if (c=='\n') {
    	kputch('\r');
    }
    kputch(c);
    return c;
}
#endif


#if 1 /* SCIF */
 /* fifo*/
void recverr(void) /* SCIF receive error  */
{
	SCIF_SCFSR &= ~(SCIF_ER | SCIF_BRK);
}
int receive(void) /* SCIF receive interrupr*/
{
	unsigned int c,r;
	r = 0;
  	c = SCIF_SCFDR & 0xf ;  /* Get read FIFO data count	*/
  	while( c > 0 )
  	{
    		getrc = SCIF_SCFRDR ;	/* Until FIFO empty	*/
    		r++ ;
    		c-- ;
  	}
  	SCIF_SCFSR = SCIF_SCFSR & ~(SCIF_RDF | SCIF_DR) ;
  				/* Clear read FIFO full flag	*/
  				/* Clear read data ready flag	*/
  	return r;

}

/* ap key read */

char _kgetchar( )	
{
	char rc;
	
    while (!receive());
	rc = getrc;
	return rc;
}

/* put char */

int kputch(c) 
int c;
{
    int i;

    while(!(SCIF_SCFSR & SCIF_TDFE));
    while(!(SCIF_SCFSR & SCIF_TEND));
	SCIF_SCFTDR = c;
	SCIF_SCFSR  = SCIF_SCFSR & ~SCIF_TEND;

	return c;

}


_kputchar(c)
int c;
{
    if (c=='\n') {
    	kputch('\r');
    }
    kputch(c);
    return c;
}
#endif

int keysw ;

#if defined(KZP01)
char kgetchar()
{
  if (keysw == 0) {
  	return _kgetchar();
  }
  else {
  	return KEY_getchar();
  }
}

kputchar(c)
int c;
{
	if (keysw == 0) {
		_kputchar(c);
	}
	else {
		scrn_putchar(c);
	}
    return c;
}
#else
char kgetchar()
{
  	return _kgetchar();
}

kputchar(c)
int c;
{
	_kputchar(c);
    return c;
}

#endif




shputchar(c)
int c;
{
    if (c=='\n') {
    	kputch('\r');
    }
    kputch(c);
    return c;
}
void charput(c)              /* One character output  */
char c;
{
	kputchar(c);
}

int sshprintk(char *format)
{
	while (*format != 0x00) {
		kputchar(*format);
		format++;
	}
}

void hbprintk(unsigned char b)
{
	hexoutb(b);
}
void hwprintk(unsigned short w)
{
	hexoutw(w);
}
void hlprintk(unsigned long l)
{
	hexoutl(l);
}
