/************************************************************
  sh_init.c (sci, scif .... initial)
  
  Date: 2000/01/01
  Revision: 1.0 $
*************************************************************/
#include "sh.h"
#include "config.h"

void sio_init(void)
{
	int	i;
/********************** SCIF initial ****************************/
	SCIF_SCSMR  =  0;
						/* 20Mhz=64 24.576Mhz=79 33Mhz=106 41.1Mhz=131	*/
#if defined(SE01SH4) || defined(CQREEKSH4)
	SCIF_SCBRR  = 106;			/* speed = 9600bps	*/
#endif
#if defined(KZP01)
	SCIF_SCBRR  = 131;			/* speed = 9600bps)	*/
#endif
	SCIF_SCSCR  = 0 ;			/* clock enable		*/
	SCIF_SCFCR  = 0 ;			/*			*/
	for( i = 0 ; i < 2100 ; i++ ) ;		/* 1bit send wait	*/
    	SCIF_SCSCR = 0;
	SCIF_SCFSR &= 0x60;			/* error flags clear	*/

	for( i = 0 ; i < 2100 ; i++ ) ;
    	SCIF_SCSCR = SCIF_TE | SCIF_RE; 	/* Send Receive irq disable */
    
/********************** SCI initial ****************************/
    	SCI_SCSMR  =  0;
#if defined(SE01SH4) || defined(CQREEKSH4)
	SCI_SCBRR  = 106;			/* speed = 9600bps	*/
#endif
#if defined(KZP01)
	SCI_SCBRR  = 131;			/* speed = 9600bps	*/
#endif
	SCI_SCSCR  = 0 ;			/* clock Enable		*/
	for( i = 0 ; i < 2100 ; i++ ) ;		/* 1bit wait		*/
    	SCI_SCSCR = 0;
	SCI_SCSSR &= 0x80;			/* error flags clear	*/
	for( i = 0 ; i < 2100 ; i++ ) ;
    	SCI_SCSCR = SCI_TE | SCI_RE;    	/* disable 		*/
}

#if defined(SE01SH4)
/*********************************************************************************/
/* HITACHI SH4 SolutionEngine hajimari
/*********************************************************************************/
union tuple{
		unsigned int	i_code;
		unsigned char	c_code[4];
} tuple_code;

unsigned char	*buffer;
/*
	MRSHPC PCcard controler ATA-card Enabler
	PCIC initialaize and ATA-card initialaize
	return value: Success:0 Failure: -1
*/
int  PCIC_card_init(unsigned char flag)
{
	  if((MRSHPC.CSR.WORD & 0x000c) == 0){ /* if card detect */
		MRSHPC.CPWCR.WORD = 0x0400;        /* power good signal mask on */
		if(MRSHPC.CSR.BIT.VS1 == 0){       /* Card Vcc is 3.3v? */
			MRSHPC.CPWCR.WORD = 0x0674;
		}
		else{                              /* Card Vcc is 5V */
			MRSHPC.CPWCR.WORD = 0x0678;
		}
		
		MRSHPC.CDCR.WORD = 0x0008;         /* memory card mode */
		MRSHPC.MW0CR1.WORD = 0x8a84;       /* enable window, window start 0xB8400000 */
		MRSHPC.MW0CR2.WORD = 0x0c00;       /* 16 bit data bus, no swap, memory mapped I/O mode */
		if(flag == ATR){
			MRSHPC.MW0CR2.WORD &= 0x0eff;  /* select atribute memory */
		}
		
		MRSHPC.CDCR.WORD = 0x0008;         /* memory card mode */
		MRSHPC.MW1CR1.WORD = 0x8a85;       /* enable common, windows start 0xB8500000 */
		MRSHPC.MW1CR2.WORD = 0x0b00;       /* 8 bit data bus, no swap, memory mapped  */
		if(flag == ATR){
			MRSHPC.MW1CR2.WORD &= 0x0fff;  /* ? */
		}
		
		MRSHPC.CDCR.WORD = 0x0008;         /* memory card mode */
		MRSHPC.IOWCR1.WORD = 0x8a86;       /* enable common, windows start 0xB8600000 */
		MRSHPC.IOWCR2.WORD = 0x0a00;       /* 8 bit data bus, no swap, I/O mapped     */
		if(flag == ATR){
			MRSHPC.IOWCR2.WORD &= 0x0fff;  /* ? */
		}
		MRSHPC.INTCR.WORD = 0x301f;
		MRSHPC.CDCR.WORD  = 0x000f;
		return	0;
	}
	else{
		return -1;
	}
}
/*********************************************************************************/
/* HITACHI SH4 SolutionEngine owari
/*********************************************************************************/
#endif /* SE01SH4 */



#if defined(KZP01)
/*********************************************************************************/
/* KZP01 KMC Solution Platform hajimari
/*********************************************************************************/
#include "bios.h"
/** config area write 32bit ***/
pci_cfgwr(bus_no,dev_no,func_no,adr,data)
UBYTE bus_no;	/* PCI BUS No. */
UBYTE dev_no;	/* Device No. */
UBYTE func_no;	/* function No. */
UBYTE adr;	/* config adr */
ULONG data;
{
	ULONG x;
	dev_no &= 0x1f;
	func_no &= 7;
	adr &= 0xfc;
	x = 0x80000000 | ((ULONG)bus_no<<16) | ((ULONG)dev_no<<11) | ((ULONG)func_no<<8) | adr;
	*(P_ULONG)0xfe2001c0 = x;
	*(P_ULONG)0xfe200220 = data;
}

/** config area read 32bit ***/
ULONG pci_cfgrd(bus_no,dev_no,func_no,adr)
UBYTE bus_no;	/* PCI BUS No. */
UBYTE dev_no;	/* Device No. */
UBYTE func_no;	/* function No. */
UBYTE adr;		/* config adr */
{
	ULONG x;
	dev_no &= 0x1f;
	func_no &= 7;
	adr &= 0xfc;
	x = 0x80000000 | ((ULONG)bus_no<<16) | ((ULONG)dev_no<<11) | ((ULONG)func_no<<8) | adr;
	*(P_ULONG)0xfe2001c0 = x;
	return *(P_ULONG)0xfe200220;
}

pci_int()
{
    unsigned int val;

    *(P_ULONG)(0xfe200004) = 0x02900007;	/* PCICONF1 */
    *(P_ULONG)(0xfe200008) = 0x06000000;	/* PCICONF2 */

/* PCIC */
    *(P_ULONG)(0xfe200010) = PCI_PCIC_ADR | 1;	/* PCICONF4 io base address 
						    SH4_PCIC map I/Oadr 0x0010_0000 - 0x001f_ffff
   						 */

/*
SH local SDRAM(aria2)
PCI MEMORY 0xff000 0000~0xfff ffff
*/

    *(P_ULONG)(0xfe200014) = PCI_DRAM_ADR & 0xfffffff0;	/* PCICONF5 memory base address */
    *(P_ULONG)(0xfe200104) = 0x00f00000;		/* PCILSR0 local space 16MB */
    *(P_ULONG)(0xfe20010C) = SH4_DRAM_ADR | 0xa0000000;	/* PCILAR0 local area3 */

/*
SH local SRAM(area4)
PCI MEMORY 0xfe00 0000~0xfef ffff
*/

    *(P_ULONG)(0xfe200018) = PCI_SRAM_ADR & 0xfffffff0;	/* PCICONF6 memory base address */
    *(P_ULONG)(0xfe200108) = 0x00f00000;		/* PCILSR1 local space 16MB */
    *(P_ULONG)(0xfe200110) = SH4_SRAM_ADR;		/* PCILAR1 local area4 */

/*
pci local bus initial
*/

    *(P_ULONG)(0xfe2001e0) = *(P_ULONG)(0xff800000);	/* PCIBCR1 */
    *(P_ULONG)(0xfe2001e4) = *(P_UWORD)(0xff800004);	/* PCIBCR2 */
    *(P_ULONG)(0xfe2001e8) = *(P_ULONG)(0xff800008);	/* PCIWCR1 */
    *(P_ULONG)(0xfe2001ec) = *(P_ULONG)(0xff80000c);	/* PCIWCR2 */
    *(P_ULONG)(0xfe2001f0) = *(P_ULONG)(0xff800010);	/* PCIWCR3 */
    *(P_ULONG)(0xfe2001f4) = *(P_ULONG)(0xff800014);	/* PCIMCR */

/*
PCI bus enable
*/
    *(P_ULONG)(0xfe200100) = 0xa5000001;	/* PCICR */

/*
PCI bus memmory upper address
*/
    *(P_ULONG)(PCI_MEM_BNK_ADR) = 0;		/* PCIMBR */


/*
PCI bus i/o upper address
*/
    *(P_ULONG)(PCI_IO_BNK_ADR) = 0;		/* PCIIOBR */


/*
PCI CR register byte swap ON
*/
#ifdef ENDIAN_BIG /* { */
//    val = *(P_ULONG)(0xfe200100);
//    *(P_ULONG)(0xfe200100) = val | 0x100;
#endif /* } */
}


/*
 SH to PCI
*/
ULONG cvt_SH2PCI(adr)
ULONG adr;	/* SH-address */
{
    int area;
    if ((adr&0x5f000000)==SH4_SRAM_ADR) { 	/* SRAM */
    	adr = PCI_SRAM_ADR | (adr &0x00ffffff);
    }
    else if ((adr&0x5f000000)==SH4_DRAM_ADR) { 	/* DRAM */
    	adr = PCI_DRAM_ADR | (adr &0x00ffffff);
    }
    else adr=-1l;			/* Error */
    return adr;
}


/*
PCI to SH
*/
ULONG cvt_PCI2SH(adr)
ULONG adr;	/* SH-address */
{
    int area;
    if ((adr & 0xff000000) == PCI_SRAM_ADR) { 	/* SRAM */
    	adr = SH4_SRAM_ADR | (adr &0x00ffffff);
    }
    else if ((adr&0xff000000) == PCI_DRAM_ADR) { 	/* DRAM */
    	adr = SH4_DRAM_ADR | (adr &0x00ffffff);
    }
    else adr=-1l;			/* Error */
    return adr;
}

/*
PCItoPCI (21150)
	I/O address   	0x00000000 - 0x7fffffff
	Memory		0x00000000 - 0xbfffffff 
	Memory		0xc0000000 - 0xc00fffff 
*/
pci_br_init()
{
    ULONG id;

    id = pci_cfgrd(0,0,0,0x0);		/* get device ID */
    pci_cfgwr(0,0,0,0x18,0x00010100);	/* bus number reg Pri=0 , Sec=1*/
					/*  I/O Address 0x00000000 - 0x7fffffff  is SecBus */
    pci_cfgwr(0,0,0,0x1c,0x0000f101);	/* io base limit addr reg */
    pci_cfgwr(0,0,0,0x30,0x7fff0000);	/* io upper base limit addr reg */
					/* Memory Address */
    pci_cfgwr(0,0,0,0x20,0xbff00000);	/* memory limit:base addr reg */
    pci_cfgwr(0,0,0,0x24,0xc001c001);	/* pre memory limit:base addr reg */

    pci_cfgwr(0,0,0,0x3c,0x00000000);	/* control reg */
    pci_cfgwr(0,0,0,0x4,0x02900007);	/* primary command reg */
}


/********************************
    IDE initial
*********************************/
ide_init()
{
    int i;
#if 1
    pci_cfgwr(1,2,0,0x58,0x44);		/* ISA bridge sirq is IDE */ 
    pci_cfgwr(1,2,0,0x44,0x1d);		/* ISA bridge /INT_enable , IDE_IRQ14 */ 
    pci_cfgwr(1,0xb,0,0x8,0x0101eac1);	/* IDE_ctrl secondary disable */
#else
    pci_cfgwr(1,2,0,0x58,0x4c);		/* ISA bridge sirq is IDE */ 
    pci_cfgwr(1,2,0,0x44,0x1d);		/* ISA bridge /INT_enable , IDE_IRQ14 */ 
    pci_cfgwr(1,2,0,0x75,0x1f);		/* ISA bridge /INT_enable , IDE_IRQ15 */ 
    pci_cfgwr(1,0xb,0,0x8,0x0101fac1);	/* IDE_ctrl secondary enable */
#endif
    pci_cfgwr(1,0xb,0,0x4,0x02800007);	/* IDE_ctrl com register */

/* IDE Timing Set praimary*/
    pci_cfgwr(1,0xb,0,0x58,0x00484802);	/* Adr_Setup = 2clk
					   CMD_recovery = 8CLK
					   CMD_active = 4CLK
					   DATA_recovery = 8CLK
					   DATA_active = 4CLK
					*/
/* IDE Timing Set Secaondary*/
    pci_cfgwr(1,0xb,0,0x5c,0x00484802);	/* Adr_Setup = 2clk
					   CMD_recovery = 8CLK
					   CMD_active = 4CLK
					   DATA_recovery = 8CLK
					   DATA_active = 4CLK
					*/
}

/********************************
    PCI SIO initial
*********************************/
pci_sio_init()
{
    ULONG id;
    id = pci_cfgrd(1,0x2,0,0x0);	/* get device ID */
    pci_cfgwr(1,0x2,0,0x4,0x0480000f);	/* SIO CMD_reg init (slow)*/
    pci_cfgwr(1,0x2,0,0x50,0x20000000);	/* RTC enable */
    pci_cfgwr(1,0x2,0,0x40,0x0000c000);	/* Key & mouse PS2 */
    pci_cfgwr(1,0x2,0,0x58,0x01000000);	/* GPIOWR use */
}

#include "font.h"
#define KEY_STAT	0x64		/* Key boord */
/*----------------------------*/
#define KEY_STAT_OB	0x1		/* out buf full */
#define KEY_STAT_IB	0x2		/* in buf full */
#define KEY_STAT_PWR	0x4		/* POWE ON */
#define KEY_STAT_CMD	0x8		/* send CMD */
#define KEY_STAT_INH	0x10		/* KEY inhibit */
#define KEY_STAT_MB	0x20		/* MOUSE out buf full */
#define KEY_STAT_TO	0x40		/* Time Out */
#define KEY_STAT_PE	0x80		/* parity error */

#define KEY_PCMD	0x64		/* KEY 64H cmd port */
/*----------------------------*/
#define KEY_DAT		0x60		/* data (60H CMD) port */
/*----------------------------*/
#define SHIFT1_DOWN	0x2a
#define SHIFT2_DOWN	0x36
#define	SHIFT1_UP	(SHIFT1_DOWN | 128)
#define	SHIFT2_UP	(SHIFT2_DOWN | 128)
#define CTRL_DOWN	0x1d
#define CTRL_UP		(CTRL_DOWN | 128)
#define	ALT_DOWN	0x38
#define	ALT_UP		(ALT_DOWN | 128)
#define CTRL		0x80
#define SHIFT		0x81
#define ALT			0x82
#define DEL			127

/* VGA-Chip define */
#define VGA_PCI_DEV_NO	0xa		/* PCI-device No */
#define PCI_BUS_NO	1		/* PCI-BUS No */
#define VGA_UMEM_BASE 	0xbf000000	/* upper MEM Base */

ULONG VRAM_BASE;			/* VRAM BaseAddr */


ULONG pci_mem_bnk(madr)
ULONG madr;		/* PCI memaddress */
{
    *(P_ULONG)(PCI_MEM_BNK_ADR) = madr & 0xff000000;	/* PCIMBR  */
    return PCI_MEM_WIN+(madr&0x00ffffff);		/* SH local address */
}


/*
    sh4pci<---> pci io
*/

#define PCI_IO_REC 1

/* PCI I/O write 8bit */
pci_iowrb(adr,data)
UWORD adr;	/* PCI IO_adr */
UBYTE data;
{
    P_UBYTE padr;
    padr = (P_UBYTE)(PCI_IO_WIN+adr);
    *padr = data;
#if PCI_IO_REC
    xwait(50);
#endif
}

/* PCI I/O write 16bit */
pci_iowrw(adr,data)
UWORD adr;	/* PCI IO_adr */
UWORD data;
{
    P_UWORD padr;
    padr = (P_UWORD)(PCI_IO_WIN+adr);
    *padr = data;
#if PCI_IO_REC
    xwait(50);
#endif
}

/* PCI I/O write 32bit */
pci_iowrl(adr,data)
UWORD adr;	/* PCI IO_adr */
ULONG data;
{
    P_ULONG padr;
    padr = (P_ULONG)(PCI_IO_WIN+adr);
    *padr = data;
#if PCI_IO_REC
    xwait(50);
#endif
}

/* PCI I/O read 8bit */
UBYTE pci_iordb(adr)
UWORD adr;	/* PCI IO_adr */
{
    P_UBYTE padr;
    UBYTE d;
    padr = (P_UBYTE)(PCI_IO_WIN+adr);
    d= *padr;

    return d;
}

/* PCI I/O read 16bit */
UWORD pci_iordw(adr)
UWORD adr;	/* PCI IO_adr */
{
    P_UWORD padr;
    UWORD d;
    padr = (P_UWORD)(PCI_IO_WIN+adr);
    d= *padr;

    return d;
}

/* PCI I/O read 32bit */
ULONG pci_iordl(adr)
UWORD adr;	/* PCI IO_adr */
{
    P_ULONG padr;
    ULONG d;
    padr = (P_ULONG)(PCI_IO_WIN+adr);
    d= *padr;

    return d;
}

/*  wait 100nsec x N */
xwait(n)
int n;
{
    int i;
    while(n--) {
        for(i=0;i<5;++i) ;
    }
}
cpuwait(n)
int n;
{
    int i;
    while(n--) {
    	for(i=0;i<250;++i);
    }
}

/* VGA initial */
ULONG VGA_init()
{
    ULONG id;
/* PCI config */
    id = pci_cfgrd(PCI_BUS_NO,VGA_PCI_DEV_NO,0,0);             /* DEVID:VENDERID */
    pci_cfgwr(PCI_BUS_NO,VGA_PCI_DEV_NO,0,0x10,VGA_UMEM_BASE); /* Upper MEM Base 0xbf000000 */
    pci_cfgwr(PCI_BUS_NO,VGA_PCI_DEV_NO,0,0x4,0x02800083);     /* DEVSEL=mid
    								  steping ON
    								  I/O enable
    								  Mem enable
    							       */
    pci_iowrb(0x3c2,3);				/* RAM : enable
    						   I/O : 3Dx
    						*/
    return id;
}

/* SR (sequencer register) write */
LVGA_SRwr(i,d)		/* SR write */
UBYTE i;		/* index */
UBYTE d;		/* data */
{
	pci_iowrb(0x3c4,i);	// index
	pci_iowrb(0x3c5,d);	// data
}

UBYTE MSRtbl[] = {0x63,0x63,0x63,0x63,0x63,0x63,0x63,0xa6,
			    0,   0,   0,   0,   0,0x63,0x63,0xa2,
		         0xa3,0xe3,0xe3,0x63};
UBYTE SRtbl[][5] = {
/* 0*/		{},
/* 1*/		{},
/* 2*/		{},
/* 3*/		{0x00,0x03,0x00,0x03,0x03},
/* 4*/		{},
/* 5*/		{},
/* 6*/		{},
/* 7*/		{},
/* 8*/		{},
/* 9*/		{},
/* a*/		{},
/* b*/		{},
/* c*/		{},
/* d*/		{},
/* e*/		{},
/* f*/		{},
/*10*/		{},
/*11*/		{},
/*12*/		{},
/*13*/    	{3,1,0xf,0,0xe}
};

UBYTE GRtbl[][9] = {
/* 0*/		{},
/* 1*/		{},
/* 2*/		{},
/* 3*/		{0,0,0,0,0,0x10,0xe,0x0f,0xff},
/* 4*/		{},
/* 5*/		{},
/* 6*/		{},
/* 7*/		{},
/* 8*/		{},
/* 9*/		{},
/* a*/		{},
/* b*/		{},
/* c*/		{},
/* d*/		{},
/* e*/		{},
/* f*/		{},
/*10*/		{},
/*11*/		{},
/*12*/		{},
/*13*/    	{0,0,0,0,0,0x40,0x5,0xf,0xff}
};

UBYTE CRtbl[][25] = {
/* 0*/	{},
/* 1*/	{},
/* 2*/	{},
/* 3*/	{0x5f,0x4f,0x50,0x82,0x54,0x80,0xbf,0x1f,0,0x4f,
	0x0e,0x0f,0,0,0,0,0x9c,0x8e,0x8f,0x28,0x11,0x96,0xb9,0xa3,0xff},
/* 4*/	{},
/* 5*/	{},
/* 6*/	{},
/* 7*/	{},
/* 8*/	{},
/* 9*/	{},
/* a*/	{},
/* b*/	{},
/* c*/	{},
/* d*/	{},
/* e*/	{},
/* f*/	{},
/*10*/	{},
/*11*/	{},
/*12*/	{},
/*13*/ 	{0x5f,0x4f,0x50,0x82,0x54,0x80,0xbf,0x1f,0x00,0x41,
    	 0,0,0,0,0,0,0x9c,0x8e,0x8f,0x28,0x40,0x96,0xb9,0xa3,0xff},
};

UBYTE ARtbl[][20] = {
/* 0*/		{},
/* 1*/		{},
/* 2*/		{},
/* 3*/    	{0,1,2,3,4,5,6,7,8,9,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,0x88,0x00,0x8f,0x08},
/* 4*/		{},
/* 5*/		{},
/* 6*/		{},
/* 7*/		{},
/* 8*/		{},
/* 9*/		{},
/* a*/		{},
/* b*/		{},
/* c*/		{},
/* d*/		{},
/* e*/		{},
/* f*/		{},
/*10*/		{},
/*11*/		{},
/*12*/		{},
/*13*/    	{0,1,2,3,4,5,6,7,8,9,0xa,0xb,0xc,0xd,0xe,0xf,0x41,  0,0xf,0}
};

/* VGA  */
ULONG VGA_mode(mode)
int mode;		/* VGA mode (mode 0x13) */
{
    ULONG vram;
    int i;
/* general control & status */
    pci_iowrb(0x3c2,MSRtbl[mode]);
    pci_iowrb(0x3da,0);

/* sr sequencer registers */
    for(i=0;i<sizeof(SRtbl[mode]);++i) {
		pci_iowrb(0x3c4,i);			// SR index
		pci_iowrb(0x3c5,SRtbl[mode][i]);	// SR data
    }

/* gr graphics controller */
    for(i=0;i<sizeof(GRtbl[mode]);++i) {
		pci_iowrb(0x3ce,i);			// GR index
		pci_iowrb(0x3cf,GRtbl[mode][i]);	// GR data
    }

/* cr crt controller reg */
    for(i=0;i<sizeof(CRtbl[mode]);++i) {
		pci_iowrb(0x3d4,i);			// CR index
		pci_iowrb(0x3d5,CRtbl[mode][i]);	// CR data
    }

/* ar attribute controller */
    pci_iordb(0x3da);			/*  AR index 
					 * st01 read address register clr
					 */
    for(i=0;i<sizeof(ARtbl[mode]);++i) {
		pci_iowrb(0x3c0,i);			// AR index (same address )
		pci_iowrb(0x3c0,ARtbl[mode][i]);	// AR data	(same address )
    }
    pci_iowrb(0x3c0,0x20);				// video enable

	if (mode == 3)
    	VGA_DAC_palett64();
	else
    	VGA_DAC_palett256();

/* VRAM address */
    vram = (GRtbl[mode][6]>>2)&3;
    if (vram==3) vram=0xb8000;
    else if (vram&2) vram=0xb0000;
    else vram=0xa0000;
    VRAM_BASE=vram;
    return vram;
}

UBYTE plt[][3] ={
/*  0 */	{0,0,0},{1,1,0x2a},{2,0x2a,0},{0,0x2a,0x2a},
/*  4 */	{0x2a,0,0},{0x2a,0,0x2a},{0x2a,0x2a,0},{0x2a,0x2a,0x2a},
/*  8 */	{0,0,0x15},{0,0,0x3f},{0,0x2a,0x15},{0,0x2a,0x3f},
/* 12 */	{0x2a,0,0x15},{0x2a,0,0x3f},{0x2a,0x2a,0x15},{0x2a,0x2a,0x3f},
/* 16 */	{0,0x15,0},{1,0x15,0x2a},{0,0x3f,0},{0,0x3f,0x2a},
/* 20 */	{0x2a,0x15,0},{0x2a,0x15,0x2a},{0x2a,0x3f,0},{0x2a,0x3f,0x2a},
/* 24 */	{0,0x15,0x15},{0,0x15,0x3f},{0,0x3f,0x15},{0,0x3f,0x3f},
/* 28 */	{0x2a,0x15,0x15},{0x2a,0x15,0x3f},{0x2a,0x3f,0x15},{0x2a,0x3f,0x3f},
/* 32 */	{0x15,0,0,},{0x15,0,0x2a},{0x15,0x2a,0},{0x15,0x2a,0x2a},
/* 36 */	{0x3f,0,0},{0x3f,0,0x2a},{0x3f,0x2a,0},{0x3f,0x2a,0x2a},
/* 40 */	{0x15,0,0x15},{0x15,0,0x3f},{0x15,0x2a,0x15},{0x15,0x2a,0x3f},
/* 44 */	{0x3f,0,0x15},{0x3f,0,0x3f},{0x3f,0x2a,0x15},{0x3f,0x2a,0x3f},
/* 48 */	{0x15,0x15,0},{0x15,0x15,0x2a},{0x15,0x3f,0},{0x15,0x3f,0x2a},
/* 52 */	{0x3f,0x15,0},{0x3f,0x15,0x2a},{0x3f,0x3f,0},{0x3f,0x3f,0x2a},
/* 56 */	{0x15,0x15,0x15},{0x15,0x15,0x3f},{0x15,0x3f,0x15},{0x15,0x3f,0x3f},
/* 60 */	{0x3f,0x15,0x15},{0x3f,0x15,0x3f},{0x3f,0x3f,0x15},{0x3f,0x3f,0x3f}
};

VGA_DAC_palett64()
{
    int i;
    UBYTE xr;
    pci_iowrb(0x3d6,0x80);	// XR80
    xr = pci_iordb(0x3d7);
    pci_iowrb(0x3d7,xr&0x7f);	// 6bit DAC

    pci_iowrb(0x3c6,0xff);	/* Paletto Mask */
    for(i=0;i<sizeof(plt)/3;++i) {
		pci_iowrb(0x3c8,i);		// index 
		pci_iowrb(0x3c9,plt[i][0]);	// R-data	
		pci_iowrb(0x3c9,plt[i][1]);	// G-data	
		pci_iowrb(0x3c9,plt[i][2]);	// B-data	
    }
}

VGA_DAC_palett256()	/* II:RR:GG:BB */
{
    int j,r,g,b,i;

    UBYTE xr;
    pci_iowrb(0x3d6,0x80);	// XR80
    xr = pci_iordb(0x3d7);
    pci_iowrb(0x3d7,xr&0x7f);	// 6bit DAC

    pci_iowrb(0x3c6,0xff);	/* Paletto Mask */
    for(j=0;j<=255;++j) {
		r=(j>>4)&3;
		g=(j>>2)&3;
		b=j&3;
		i=(j>>6)&3;
		r+=i;
		g+=i;
		b+=i;
	
		r=r*9+9;
		g=g*9+9;
		b=b*9+9;

		pci_iowrb(0x3c8,j);	// index 
		pci_iowrb(0x3c9,r);	// R-data	
		pci_iowrb(0x3c9,g);	// G-data	
		pci_iowrb(0x3c9,b);	// B-data	
    }
}

/* Tsxt Mode initial */
dsp_init()
{
    UBYTE gr,*f,*vram;
    int i,j;

    VGA_mode(3); /* ? */

/* Sequencer Registers */
    pci_iowrb(0x3c4,0);
    pci_iowrb(0x3c5,0x01); /* Synchronous reset */
    pci_iowrb(0x3c4,2);
    pci_iowrb(0x3c5,0x04); /* CPU writes only to plane 2 */
    pci_iowrb(0x3c4,4);
    pci_iowrb(0x3c5,0x07); /* Sequential addressing */
    pci_iowrb(0x3c4,0);
    pci_iowrb(0x3c5,0x03); /* Clear Synchronous reset */
    
/* Grephics Controller Reg */
    pci_iowrb(0x3ce,4);
    pci_iowrb(0x3cf,0x02); /* slect plane 2 */
    pci_iowrb(0x3ce,5);
    pci_iowrb(0x3cf,0x00); /* disable odd-even adressing */
    pci_iowrb(0x3ce,6);
    pci_iowrb(0x3cf,0x0c); /* old 0x0c map start */

    vram = (UBYTE *)pci_mem_bnk(VRAM_BASE);
    f=(UBYTE *)fontdata_8x16; /* Font table */
    for(i=0; i< 0x100; ++i) {
    	for(j=0; j < 0x10; j++) {
        	*vram++ = *f++;			/* CG load */
    	}
    	for(j=0; j < 0x10; j++) {
        	*vram++ = 0x00;			/* CG load */
    	}
    }
/* Sequencer Registers */
    pci_iowrb(0x3c4,0);
    pci_iowrb(0x3c5,0x01);	/* Synchronous reset */
    pci_iowrb(0x3c4,2);
    pci_iowrb(0x3c5,0x03);	/* CPU write to map 0 and 1 */
    pci_iowrb(0x3c4,4);
    pci_iowrb(0x3c5,0x03);	/* odd-even addressing */
    pci_iowrb(0x3c4,3);
    pci_iowrb(0x3c5,0x04);	/* font select 0 or 4*/
    pci_iowrb(0x3c4,0);
    pci_iowrb(0x3c5,0x03);	/* Clear Synchronous reset */
    
/* Grephics Controller Reg */
    pci_iowrb(0x3ce,4);
    pci_iowrb(0x3cf,0x00); 	/* select map 0 for cpu */
    pci_iowrb(0x3ce,5);
    pci_iowrb(0x3cf,0x10);	/* enable odd-even addressing */
    pci_iowrb(0x3ce,6);
    pci_iowrb(0x3cf,0x0e);  	/* map starts at b8000 */
    
/* ar attribute controller */
    pci_iordb(0x3da);	       /* clear */
    pci_iowrb(0x3c0,0x12);     /* Memory plane enable register */
    pci_iowrb(0x3c0,0x07);     /* p0, p1, p2 enable */
    pci_iordb(0x3da);	       /* clear */
    pci_iowrb(0x3c0,0x20);     /*  video enable */
    
    vram = (UBYTE *)pci_mem_bnk(VRAM_BASE);
    for(i=0;i<0x4000;++i) {
        *vram++ = 0x20;		/* TXT sample */
        *vram++ = 0x07;
    }

}

/***************************************
	Text display sample at MODE 3
****************************************/
#define XX 80
#define YY 25

int CUR_X,CUR_Y;
int screenx ;
int screeny ;

/* vga clear */
crt_cls()
{
    UBYTE *vram;
    int i;
    vram = (UBYTE *)pci_mem_bnk(VRAM_BASE);
    for(i=0;i<XX*YY;++i) {
        *vram++ = 0x20;
        *vram++ = 0x07;
    }
    CUR_X=CUR_Y=0;
    screenx = 0;
    screeny = 0;
}

/* cur clear */
crt_cur(x,y)
int x,y;
{
int cur;
    cur = x + y*XX;
    pci_iowrb(0x3d4,0x0f);
    pci_iowrb(0x3d5,cur & 0xff); 
    pci_iowrb(0x3d4,0x0e);
    pci_iowrb(0x3d5,(cur >> 8) & 0xff); 
}

/* 1char display */
crt_1char(ch,x,y,co,si)
UBYTE ch;
int x,y;
UBYTE co;
int si;	
{
    UBYTE *vram,*fnt,d;
    int cx,cy;

    if (x==-1) {
        x=CUR_X;
        y=CUR_Y;
    }

    vram  = (UBYTE *)pci_mem_bnk(VRAM_BASE);
    vram += x*2 + y*XX*2 - 2;
    *vram++ = ch;
    *vram++ = co;

    CUR_X=x;
    CUR_Y=y;
    if (++CUR_X>=XX) {
        CUR_X=0;
        ++CUR_Y;
    }
    crt_cur(x,y);
}


/* n char diplay */
crt_str(s,x,y,co,si)
UBYTE *s;
int x,y;
UBYTE co;
int si;
{
    if (x==-1) {
        x=CUR_X;
        y=CUR_Y;
    }
    while(*s) {
        crt_1char(*s++,x,y,co,si);
        if (++x>=XX) {
	    	x=0;
            ++y;
		}
    }
    CUR_X=x;
    CUR_Y=y;
}

void scrn_putchar(c)
int c;
{
	volatile unsigned char *p;

	switch (c) {
		case '\n':	
			screenx = 0;
			screeny++;
			crt_cur(screenx,screeny);
		case '\r':	
			return;
			break;
		case 'H'-'@':		/* '\b' */
		case DEL:
			screenx--;
			if (screenx < 0) {
				if (screeny) {
					screeny--;
					screenx = XX-1;
				}
				else
					screenx =  0;
			}
			break;
		default:
			screenx++;
			if (screenx >= XX) {
				screenx = 0;
				screeny++;
			}
			break;
	}

	if (screeny >= YY) {
	  crt_cls();
	  screeny = 0;
	}
	crt_1char(c,screenx, screeny,0x07,1);
}

/*##################################
	KEY PS2
####################################*/

int shifton ;
/* CMD send to Key */
KEY_tx(d)
{
    int st;
    for(;;) {
        st=pci_iordb(KEY_STAT);
	xwait(10);
        if ((st & KEY_STAT_IB)==0) break;	/* IN BUF FULL ? */
    }
    pci_iowrb(KEY_DAT,d);
    xwait(10);
}

/* recieve from KEY stat check */
UBYTE KEY_rx_chk()
{
    int st,i;
	st=pci_iordb(KEY_STAT);
	if (st & KEY_STAT_OB) return 1;	/* OUT BUF FULL ? */
    return 0;	/* no data */
}


/* recieve from KEY */
UBYTE KEY_rx()
{
    int st;
    while(KEY_rx_chk()==0) ;
    st=pci_iordb(KEY_DAT);
    xwait(10);
    return st;
}

/**********************************
* key board initial
***********************************/

KEY_init()
{
    int st,i;
 /* SIO-cfg port Key enable */
    pci_iowrb(0x3f0,0x51);
    pci_iowrb(0x3f0,0x23);
    pci_iowrb(0x3f0,0x7);
    pci_iowrb(0x3f0,0x30);
    pci_iowrb(0x3f1,0x1);
    pci_iowrb(0x3f0,0xf0);
    pci_iowrb(0x3f1,0x20);
    pci_iowrb(0x3f0,0xbb);

    pci_iowrb(KEY_DAT,0xff);	/* Key Reset */

    for(i=0;i<100;++i) {
    	if (KEY_rx_chk()) {
	    st=KEY_rx();
    	    if (st==0xfe) return 1;	/* Key error */
    	    if (st==0xaa) return 0;	/* Key OK */
    	}
    	xwait(100);
    }
    return 1;
}

UBYTE key_tbl[]={
	-1, 27, '1', '2', '3', '4', '5', '6',
	'7', '8', '9', '0', '-', '=', 'H' - '@', '\t',
	'q', 'w', 'e', 'r', 't', 'y', 'u', 'i',
	'o', 'p', '[', ']', '\r', CTRL, 'a', 's',
	'd', 'f', 'g', 'h', 'j', 'k', 'l', ';',
	'\'', '`', SHIFT, '\\', 'z', 'x', 'c', 'v',
	'b', 'n', 'm', ',', '.', '/', SHIFT, -1,
	 ALT, ' ', -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, DEL
    };

UBYTE skey_tbl[]={
	-1, 27, '!', '@', '#', '$', '%', '^',
	'&', '*', '(', ')', '_', '+', 'H' - '@', '\t',
	'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I',
	'O', 'P', '{', '}', '\r', CTRL, 'A', 'S',
	'D', 'F', 'G', 'H', 'J', 'K', 'L', ':',
	'\"', '~', SHIFT, '|', 'Z', 'X', 'C', 'V',
	'B', 'N', 'M', '<', '>', '?', SHIFT, -1,
	 ALT, ' ', -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, DEL
    };

UBYTE
KEY_getchar()
{
	int i,retval;

	i = 0;
	retval = -1;

	do {
		i=KEY_rx();
		switch (i) {
		case SHIFT1_UP:
		case SHIFT2_UP:
			shifton = 0;
			break;
		case SHIFT1_DOWN:
		case SHIFT2_DOWN:
			shifton = 1;
			break;
		case CTRL_DOWN:
		case CTRL_UP:
			break;
		case ALT_DOWN:
		case ALT_UP:
			break;
		default:
			if (!(i & 0x80) && i < sizeof(key_tbl)) { /* It's a down */
				if (shifton)
					retval = skey_tbl[i];
				else
					retval = key_tbl[i];
			}
		}
	} while (retval == -1);
	return(retval);
}
/*********************************************************************************/
/* KZP01 KMC Solution Platform owari
/*********************************************************************************/
#endif /* KZP01 */
