/************************************************************
  Copyright (C) 2001 Nobuhiro Sakawa
  Date: 2001/01/01
  Revision: 1.0 $
*************************************************************/
/*  sh4 initial & start */
/*
 *
 *   SE01SH4
 *
 */


asm("
	.little
	.text
	.align	2

	.org 	0
start:
_start:
	mov.l	@(astart+4,pc),r0
	ldc	r0,sr
	mov.l	@(astart+8,pc),r0
	ldc	r0,vbr

	mov.l	@(astart,pc),r0
	jmp	@r0
	nop
	
	.align	4
astart:
	.long	Astart      /* sh4 initial org 0x800  */
	.long   0x600000f0  /* initial SR */
	.long	0xA0000000  /* VBR */

/*
Exception Vecter Address
*/
	.org 0x100
	mov.l	@(sys_err100,pc),r0
	jmp	@r0
	nop

	.align	4
sys_err100:
	.long	Sys_err100     	
Sys_err100:
	nop
	bra	Sys_err100
	nop

/*
TLB miss Vecter Address
*/
	.org 0x400
	mov.l	@(sys_err400,pc),r0
	jmp	@r0 
	nop
	
	.align	4
sys_err400:
	.long	Sys_err400     	
Sys_err400:
	nop
	bra	Sys_err400
	nop
/*
Interrupt  Vecter address
*/
	.org 0x600
	mov.l	@(sys_err600,pc),r0
	jmp	@r0 
	nop
	
	.align	4
sys_err600:
	.long	Sys_err600     	
Sys_err600:
	nop
	bra	Sys_err600
	nop

/*
  sh4 initial 
*/
    .org 0x800
Astart:
/* BCR1 = 0x00000008   Area 3= SRAM Area5.6=PCMCIA */
	mov.l	@(BCR1,pc),r13
	mov	#0x00,r0
	shll8   r0
	or      #0x00,r0
	shll8   r0
	or      #0x00,r0
	shll8   r0
	or      #0x08,r0
	mov.l	r0,@r13
/* BCR2 = 0x2e3c  */
	mov.l	@(BCR2,pc),r13
	mov	#0x2e,r0
	shll8	r0
	or	#0x3c,r0
	mov.w	r0,@r13
/* WCR1 = 0x02720777   */
	mov.l	@(WCR1,pc),r13
	mov	#0x02,r0
	shll8   r0
	or      #0x72,r0
	shll8   r0
	or      #0x07,r0
	shll8   r0
	or      #0x77,r0
	mov.l	r0,@r13
/* WCR2 = 0xfffe4fff   */
	mov.l	@(WCR2,pc),r13
	mov	#0xff,r0
	shll8   r0
	or      #0xfe,r0
	shll8   r0
	or      #0x4f,r0
	shll8   r0
	or      #0xff,r0
	mov.l	r0,@r13
/* WCR3 = 0x01717771   */
	mov.l	@(WCR3,pc),r13
	mov	#0x01,r0
	shll8   r0
	or      #0x71,r0
	shll8   r0
	or      #0x77,r0
	shll8   r0
	or      #0x71,r0
	mov.l	r0,@r13
/* MCR = 0x8801001c   */
	mov.l	@(MCR,pc),r13
	mov	#0x88,r0
	shll8   r0
	or      #0x01,r0
	shll8   r0
	or      #0x00,r0
	shll8   r0
	or      #0x1c,r0
	mov.l	r0,@r13
/* RTCOR = a508*/
	mov.l	@(RTCOR,pc),r13
	mov	#0xa5,r0
	shll8   r0
	or      #0x08,r0
	mov.w	r0,@r13	
/* RTCSR = 0xa518    */
	mov.l	@(RTCSR,pc),r13
	mov	#0xa5,r0
	shll8   r0
	or      #0x18,r0
	mov.w	r0,@r13	
/* PCR = 0x0912 
	mov.l	@(PCR,pc),r13
	mov	#0x09,r0
	shll8   r0
	or      #0x12,r0
	mov.w	r0,@r13	
	*/
/* SDRAM set */
    	mov.l   @(SDRAM,pc),r13
    	mov     #0x00,r0
    	mov.b   r0,@r13
    	mov.l   @(RFCR,pc),r12
	mov     #0xa4,r0
	shll8	r0
	or      #0x00,r0
	mov.w   r0,@r12
lrfcr:
	mov.w   @r12,r0
	and     #0x08,r0
	cmp/eq  #0x08,r0
	bf	lrfcr
	nop
	

	/* MCR = 0xc801001c   */
	mov.l	@(MCR,pc),r12
	mov	#0xc8,r0
	shll8   r0
	or      #0x01,r0
	shll8   r0
	or      #0x00,r0
	shll8   r0
	or      #0x1c,r0
	mov.l	r0,@r12
	
	mov     #0x00,r0
	mov.b   r0,@r13

	mov.l	@(Bstack,pc),r15
	mov.l	@(Bstart,pc),r0
	jmp	@r0
	nop

	.align	4
Bstart:
	.long	main
Bstack:
	.long   0x8d000000		
BCR1:
	.long	0xff800000
BCR2:
	.long	0xff800004
WCR1:
	.long	0xff800008
WCR2:
	.long   0xff80000c
WCR3:
	.long	0xff800010
MCR:
	.long   0xff800014
PCR:
	.long   0xff800018
RTCSR:
	.long   0xff80001c
RTCNT:
	.long   0xff800020
RTCOR:
	.long	0xff800024
RFCR:
	.long   0xff800028
SDRAM:
	.long   0xff940110

");



