/************************************************************
	romlib.c ( gcc rom Library )

	from gcc2.97
*************************************************************/
long normal_long(data)
{
#if 0
	return *(long *)data;
#else
	unsigned char *p;
	unsigned char tmp[4];
	
	p=(unsigned char *)&data;
	tmp[0]=p[3]; tmp[1]=p[2]; tmp[2]=p[1]; tmp[3]=p[0];
	return *(long *)tmp;
#endif
}
short normal_short(data)
{
#if 0
	return *(short *)data;
#else
	unsigned char *p;
	unsigned char tmp[2];
	
	p=(unsigned char *)&data;
	tmp[0]=p[1]; tmp[1]=p[0];
	return *(short *)tmp;
#endif
}

void bcopy(char *dest,char *src,int c)
{
    while(c--) {
      *((char *)dest)++ = *((char *)src)++;
    }
}

void *memcpy(char *dest,char *src, int c)
{
    char *rval;
    rval = dest;
    while(c--) {
      *((char *)dest)++ = *((char *)src)++;
    }
    return rval;
}

int strlen(char *start)
{
    char *end;
    end = start;
    for(;;){
	if (*end == 0) return (end - start);
	++end;
    }
}

int strncmp(char *s1, char *s2, int len)
{
    unsigned char c,d;
    while(len--) {
	c = *((unsigned char *)s1)++;
	d = c - *((unsigned char *)s2)++;
	if ( d || c == 0 ) return d;
    }
    return 0;
}

/*******************************************************/
#if 0

asm("
	.align	2
	.globl	__udivsi3
__udivsi3:
	xor	r0,r0
	tst	r5,r5
	bt	zero_div
	div0u

	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0

	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0

	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0

	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0

	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0

	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0

	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0

	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0
	rotcl	r4
	div1	r5,r0

	rotcl	r4
	rts
	mov	r4,r0

zero_div:
	.word	0x0ff0	
	bra	zero_div
	nop

	.global	__sdivsi3
__sdivsi3:
	tst	r5,r5
	bt	zero_div
	mov	r4,r1
	mov	r5,r0
	xor	r2,r2
	div0s	r2,r1
	subc	r3,r3
	subc	r2,r1
	div0s	r0,r3

	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3

	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3

	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3

	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3

	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3

	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3

	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3

	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3

	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3
	rotcl	r1
	div1	r0,r3

	rotcl	r1
	addc	r2,r1
	rts
	mov	r1,r0

");
#endif

