/************************************************************
  sh_init.c (sci, scif .... initial)
  
  Date: 2000/01/01
  Revision: 1.0 $
*************************************************************/
#include "sh.h"
#include "config.h"
#include "ide.h"

void sio_init(void)
{
	int	i;
/********************** SCIF initial ****************************/
	SCIF_SCSMR  =  0;
						/* 20Mhz=64 24.576Mhz=79 33Mhz=106 41.1Mhz=131	*/
#if defined(SE01SH4) || defined(CQREEKSH4)
	SCIF_SCBRR  = 106;			/* speed = 9600bps	*/
#endif
#if defined(KZP01)
	SCIF_SCBRR  = 131;			/* speed = 9600bps)	*/
#endif
	SCIF_SCSCR  = 0 ;			/* clock enable		*/
	SCIF_SCFCR  = 0 ;			/*			*/
	for( i = 0 ; i < 2100 ; i++ ) ;		/* 1bit send wait	*/
    	SCIF_SCSCR = 0;
	SCIF_SCFSR &= 0x60;			/* error flags clear	*/

	for( i = 0 ; i < 2100 ; i++ ) ;
    	SCIF_SCSCR = SCIF_TE | SCIF_RE; 	/* Send Receive irq disable */
    
/********************** SCI initial ****************************/
    	SCI_SCSMR  =  0;
#if defined(SE01SH4) || defined(CQREEKSH4)
	SCI_SCBRR  = 106;			/* speed = 9600bps	*/
#endif
#if defined(KZP01)
	SCI_SCBRR  = 131;			/* speed = 9600bps	*/
#endif
	SCI_SCSCR  = 0 ;			/* clock Enable		*/
	for( i = 0 ; i < 2100 ; i++ ) ;		/* 1bit wait		*/
    	SCI_SCSCR = 0;
	SCI_SCSSR &= 0x80;			/* error flags clear	*/
	for( i = 0 ; i < 2100 ; i++ ) ;
    	SCI_SCSCR = SCI_TE | SCI_RE;    	/* disable 		*/
}

#if defined(SE01SH4)
/*********************************************************************************/
/* HITACHI SH4 SolutionEngine hajimari
/*********************************************************************************/
union tuple{
		unsigned int	i_code;
		unsigned char	c_code[4];
} tuple_code;

unsigned char	*buffer;
/*
	MRSHPC PCcard controler ATA-card Enabler
	PCIC initialaize and ATA-card initialaize
	return value: Success:0 Failure: -1
*/
int  PCIC_card_init(unsigned char flag)
{
 	  MRSHPC.CSR.WORD = 0x474;
	  {
		int i;
		for(i=0; i < 1000; i++){}
	  }
	  if((MRSHPC.CSR.WORD & 0x000c) == 0){ /* if card detect */
		MRSHPC.CPWCR.WORD = 0x0400;        /* power good signal mask on */
		if((MRSHPC.CSR.WORD & 0x0080) == 0){       /* Card Vcc is 3.3v? */
			MRSHPC.CPWCR.WORD = 0x0674;
		}
		else{                              /* Card Vcc is 5V */
			MRSHPC.CPWCR.WORD = 0x0678;
		}
		
		MRSHPC.CDCR.WORD = 0x0008;         /* memory card mode */
		MRSHPC.MW0CR1.WORD = 0x8a84;       /* enable window, window start 0xB8400000 */
		MRSHPC.MW0CR2.WORD = 0x0c00;       /* 16 bit data bus, no swap, memory mapped I/O mode */
		if(flag == ATR){
			MRSHPC.MW0CR2.WORD &= 0x0eff;  /* select atribute memory */
		}
		
		MRSHPC.CDCR.WORD = 0x0008;         /* memory card mode */
		MRSHPC.MW1CR1.WORD = 0x8a85;       /* enable common, windows start 0xB8500000 */
		MRSHPC.MW1CR2.WORD = 0x0b00;       /* 8 bit data bus, no swap, memory mapped  */
		if(flag == ATR){
			MRSHPC.MW1CR2.WORD &= 0x0fff;  /* ? */
		}
		
		MRSHPC.CDCR.WORD = 0x0008;         /* memory card mode */
		MRSHPC.IOWCR1.WORD = 0x8a86;       /* enable common, windows start 0xB8600000 */
		MRSHPC.IOWCR2.WORD = 0x0a00;       /* 8 bit data bus, no swap, I/O mapped     */
		if(flag == ATR){
			MRSHPC.IOWCR2.WORD &= 0x0fff;  /* ? */
		}
		MRSHPC.INTCR.WORD = 0x301f;
		MRSHPC.CDCR.WORD  = 0x000f;
		return	0;
	}
	else{
		return -1;
	}
}
/*
 * Configure the Super I/O chip
 */
#define CONFIG_PORT	0x3f0
#define INDEX_PORT	0x3f0
#define DATA_PORT	0x3f1
#define CONFIG_ENTER	0x55
#define CONFIG_EXIT	0xaa
#define CURRENT_LDN_INDEX	0x07
#define ACTIVATE_INDEX		0x30
#define IRQ_SELECT_INDEX	0x70
#define GPIO46_INDEX		0xc6
#define GPIO47_INDEX		0xc7
#define LDN_IDE1		1
#define LDN_AUXIO		8	
static  void delay(void)
{
	unsigned short dummy,i;
	for(i=0; i<2; i++) {
		dummy = *(volatile unsigned short *)(0xa0000000);
	}
}
static void smsc_out(unsigned long value, unsigned short port)
{
	unsigned long r_port;
	r_port = PA_SUPERIO + (port << 1);
	*(volatile unsigned short *)r_port = value << 8;
}
static void smsc_config (int index, int data)
{
	smsc_out(index,INDEX_PORT);
	delay();
	smsc_out(data,DATA_PORT);
	delay();
}
void smsc_init(void)
{
	smsc_out(CONFIG_ENTER,CONFIG_PORT);
	delay();
	smsc_out(CONFIG_ENTER,CONFIG_PORT);
	delay();
	/* IDE1 */
	smsc_config(CURRENT_LDN_INDEX, LDN_IDE1);
	smsc_config(ACTIVATE_INDEX, 0x01);
	smsc_config(IRQ_SELECT_INDEX, 14);
	/* AUXIO (GPIO): to use IDE1*/
	smsc_config(CURRENT_LDN_INDEX, LDN_AUXIO);
	smsc_config(ACTIVATE_INDEX, 0x01);
	smsc_config(GPIO46_INDEX, 0x00);
	smsc_config(GPIO47_INDEX, 0x00);
	delay();
	smsc_out(CONFIG_EXIT,CONFIG_PORT);
}
/*********************************************************************************/
/* HITACHI SH4 SolutionEngine owari
/*********************************************************************************/
#endif /* SE01SH4 */


